/* TODO: 
 * 
 * 
 * 
 * CheatDetector
 * 
 * support:
 * bf3-ingame-name: onegrizzlybeer (http://battlelog.battlefield.com/bf3/user/onegrizzlybeer/)
 * procon-forum-name: grizzlybeer (http://www.phogue.net/forumvb/member.php?13930-grizzlybeer)
 */

using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Players;

using System;
using System.Collections.Generic;
using System.Net;
using System.Text.RegularExpressions;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Text;
using System.Windows.Forms;
using PRoCon.Core.Plugin.Commands;
using MySql.Data.MySqlClient;
using System.Web;

namespace PRoConEvents
{
    public class CheatDetector : PRoConPluginAPI, IPRoConPluginInterface
    {
        #region class, contructor        
        private object killlock;
        private enumBoolYesNo DoStatsCheck;
        private enumBoolYesNo DoLiveCheck;

        private WebClient webclient;
        private DBConnect DB;
        private List<string> tempplayertocheck;
        private enumBoolYesNo test;

        private enumBoolYesNo publicintegration;
        
        private List<string> whitelist;
        private enumBoolYesNo includereservedslots;
        private enumBoolYesNo excludereservedslots;

        private enumBoolYesNo enablekick; //enable action kick
        private string kicktext; //text to be displayed to the kicked player
        private enumBoolYesNo enabletban; //enable action tban
        private string tbantext; //text to be displayed to the tbanned player
        private int tbantime; //tban length
        private enumBoolYesNo enableban; //enable action ban
        private string bantext; //text to be displayed to the banned player  
        private enumBoolYesNo banbyname;
        private enumBoolYesNo banbyeaguid;
        private enumBoolYesNo banbypbguid;
        private enumBoolYesNo enableingamenotify; //enable action notify (std)
        private enumBoolYesNo enableingameprivpyell;
        private enumBoolYesNo enableingameprivpsay;
        private enumBoolYesNo enableingamepubnotifysay;
        private enumBoolYesNo enableingamepubnotifyyell;
        private string publicnotifysaytext;
        private string publicnotifyyelltext;
        private string privatenotifypsaytext;
        private string privatenotifypyelltext;
        private int ingameprivnotifytime; //display time
        private int ingamepublicnotifytime; //display time
        private List<string> ingameaccountnamepyell; //admin ingame username to display notify to
        private List<string> ingameaccountnamepsay; //admin ingame username to display notify to
        private int debuglevel; //spam debug output to console (0-5)
        //private BattlelogClient bclient;
        private List<String> myplayerlist;
        private bool SyncResetPlayerLists;
        private int SyncResetListsHelper;
        //private int cheatindex;
        private enumBoolYesNo advanced;
        //private double yellowacc;
        //private double orangeacc;
        //private double redacc;
        //private double yellowhspk;
        //private double orangehspk;
        //private double redhspk;
        //private double yellowkph;
        //private double orangekph;
        //private double redkph;
        //private double orangekpm;
        //private double redkpm;
        private double orangespm;
        private double redspm;
        private double orangeflagcount;
        private double redflagcount;
        private int minkills;
        //private String result;
        //private string playername;

        private Dictionary<string, CPlayerInfo> m_dicPlayerInfo;
        private Dictionary<string, CPunkbusterInfo> m_dicPBPlayerInfo;
        private List<string> queue;
        private DateTime lastcheck;
        private DateTime viplastcheck;
        private DateTime lastcheck2;
        private DateTime lastdbsend;
        private int batchsize;
        private double batchtimeout;
        private double batchtimeoutbase;
        private double batchtimeoutnormal;
        //private double batchtimeoutsleep;
        private double batchtimeoutmax;
        private double batchtimeoutmodinc;
        private double batchtimeoutmoddec;

        private enumBoolYesNo logtofile;
        private string logfilename;

        private enumBoolYesNo timeouttest;

        private Dictionary<string, int> playerErrors;
        private int retries;
        private Dictionary<string, Dictionary<string, string>> CacheDict;
        private enumBoolYesNo useCache;
        //private string magic;

        private enumBoolYesNo lazyQueue;

        private String UserAgent;

        private enumBoolYesNo streamtomaster;

        public string queueServer;
        public string queueDB;
        public string queueUser;
        public string queuePwd;

        private enumBoolYesNo DoConnect;

        private List<PlayerCheckInfo> queuefordb;

        private Dictionary<string, double> kills;
        private Dictionary<string, double> hs;
        private Dictionary<string, DateTime> firstkill;

        private double maxhsklive;
        private double maxkmlive;
        private double minkillslive;

        private enumBoolYesNo strictmode;

        public CheatDetector()
        {
            killlock = new object();
            DoStatsCheck = enumBoolYesNo.Yes;
            DoLiveCheck = enumBoolYesNo.Yes;

            publicintegration = enumBoolYesNo.Yes;
            webclient = new WebClient();            
            
            DB = new DBConnect(this);
            enablekick = enumBoolYesNo.No;
            kicktext = "SUSPECTED CHEATING: %playername% %suspiciousstat%";
            enabletban = enumBoolYesNo.Yes;
            tbantext = "SUSPECTED CHEATING: %playername% %suspiciousstat%";
            tbantime = 15;
            enableban = enumBoolYesNo.No;
            bantext = "SUSPECTED CHEATING: %playername% %suspiciousstat%";
            banbyname = enumBoolYesNo.No;
            banbyeaguid = enumBoolYesNo.Yes;
            banbypbguid = enumBoolYesNo.No;
            enableingamenotify = enumBoolYesNo.Yes;
            enableingamepubnotifysay = enumBoolYesNo.Yes;
            enableingamepubnotifyyell = enumBoolYesNo.No;
            enableingameprivpyell = enumBoolYesNo.No;
            enableingameprivpsay = enumBoolYesNo.No;
            ingameaccountnamepyell = new List<string>();
            ingameaccountnamepyell.Add("onegrizzlybeer");
            ingameaccountnamepsay = new List<string>();
            ingameaccountnamepsay.Add("onegrizzlybeer");
            publicnotifysaytext = "CheatDetector - SUSPECTED CHEATING: %playername% %suspiciousstat%";
            publicnotifyyelltext = "CheatDetector - SUSPECTED CHEATING: %playername% %suspiciousstat%";
            privatenotifypsaytext = "CheatDetector - SUSPECTED CHEATING: %playername% %suspiciousstat%";
            privatenotifypyelltext = "CheatDetector - SUSPECTED CHEATING: %playername% %suspiciousstat%";
            ingameprivnotifytime = 30;
            ingamepublicnotifytime = 30;
            debuglevel = 1;
            //bclient = new BattlelogClient(this);
            myplayerlist = new List<String>();
            SyncResetPlayerLists = false;
            SyncResetListsHelper = 0;
            //cheatindex = 0;
            whitelist = new List<string>();
            includereservedslots = enumBoolYesNo.Yes;
            excludereservedslots = enumBoolYesNo.Yes;

            playerErrors = new Dictionary<string, int>();
            retries = 1;
            tempplayertocheck = new List<string>();
            test = enumBoolYesNo.No;
            advanced = enumBoolYesNo.No;
            //yellowacc = 2.4;
            //orangeacc = 3.2;
            //redacc = 3.7;
            //yellowhspk = 1.83;
            //orangehspk = 2.7;
            //redhspk = 3.2;
            //yellowkph = 1.84;
            //orangekph = 2.7;
            //redkph = 3.2;
            //orangekpm = 5.0;
            //redkpm = 8.0;
            orangespm = 1100;
            redspm = 1600;
            orangeflagcount = 1.5;
            redflagcount = 5.0;
            minkills = 130;
            
            minkillslive = 20;
            maxhsklive = 0.91;
            maxkmlive = 8.0;

            m_dicPlayerInfo = new Dictionary<string, CPlayerInfo>();
            m_dicPBPlayerInfo = new Dictionary<string, CPunkbusterInfo>();
            queue = new List<string>();
            lastcheck = new DateTime();
            lastcheck = DateTime.Now.AddMinutes(-3.0);
            viplastcheck = new DateTime();
            viplastcheck = DateTime.Now.AddMinutes(-3.0);
            lastcheck2 = new DateTime();
            lastcheck2 = DateTime.Now.AddMinutes(-3.0);
            lastdbsend = new DateTime();
            lastdbsend = DateTime.Now.AddMinutes(-3.0);
            batchsize = 1;
            batchtimeoutbase = 29.0;
            batchtimeoutnormal = 29.0;
            batchtimeout = batchtimeoutnormal;
            //batchtimeoutsleep = 150.0;
            batchtimeoutmax = 300.0;
            batchtimeoutmodinc = 60.0;
            batchtimeoutmoddec = 30.0;

            logtofile = enumBoolYesNo.No;
            logfilename = "Plugins/BF3/CDLogFile.txt";

            timeouttest = enumBoolYesNo.No;

            CacheDict = new Dictionary<string, Dictionary<string, string>>();
            useCache = enumBoolYesNo.Yes;
            //magic = "|" + GenerateRandomString() + "|";
            //magic = "|sgdfgdsgdfgdfgdfg|";

            lazyQueue = enumBoolYesNo.No;

            UserAgent = "Mozilla/5.0 (compatible; PRoCon 1; CheatDetector)";
            webclient.Headers.Add("user-agent", UserAgent);

            streamtomaster = enumBoolYesNo.No;
            queueServer = "";
            queueDB = "";
            queueUser = "";
            queuePwd = "";
            DoConnect = enumBoolYesNo.No;
            queuefordb = new List<PlayerCheckInfo>();

            kills = new Dictionary<string, double>();
            hs = new Dictionary<string, double>();
            firstkill = new Dictionary<string, DateTime>();

            strictmode = enumBoolYesNo.No;
        }
        #endregion

        #region Description, LevelLoaded, PluginEnable, PluginDisable, PluginLoaded
        public string GetPluginName()
        {
            return "CheatDetector";
        }

        public string GetPluginVersion()
        {
            return "0.4.2";
        }

        public string GetPluginAuthor()
        {
            return "onegrizzlybeer";
        }

        public string GetPluginWebsite()
        {
            return "www.phogue.net/forumvb/showthread.php?5414-CheatDetector-%28CD%29";
        }

        public string GetPluginDescription()
        {
            return @"
<h1>CD - CheatDetector [BF3]</h1>
<p>If you like this plugin, please donate using the button below. Any amount is considered helpful. Thank you :-)<br>
<form action=""https://www.paypal.com/cgi-bin/webscr"" method=""post"" target=""_blank"">
<input type=""hidden"" name=""cmd"" value=""_s-xclick"">
<input type=""hidden"" name=""hosted_button_id"" value=""CL3WW8C3J7BW6"">
<input type=""image"" src=""https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif"" border=""0"" name=""submit"" alt=""PayPal - The safer, easier way to pay online!"">
<img alt="" border=""0"" src=""https://www.paypalobjects.com/de_DE/i/scr/pixel.gif"" width=""1"" height=""1"">
</form></p>
<h2>Description</h2>
<h3>Stats Check</h3>
<p>This plugin tries to detect cheaters by their BF3 Battlelog Stats. This is done in the following way:<br>
When a new player has joined (by detecting new entries in the playerlist. not by the playerjoined event, to prevent spamming) his stats are fetched from his Battlelog page (3 requests).<br>
This is done for 1 player every 30 seconds, to not trigger any restrictions on the Battlelog side using a fifo-queue (first in, first out. or fcfs (first come, first served))<br>
Then every weapons stat (with more than 130 kills, or more headshots than kills with more than 20 kills) is checked against a collection of averages to decide if its normal, suspicious or impossible.<br><br>

You can also use BattlelogCache to reduce the traffic on Battlelog.<br><br>

The following stats are checked:<br>
Player SPM (score per minute)<br>
Weapon k/m (KPM, kills per minute)<br>
Weapon hs/k (HSPK, headshots per kill)<br>
Weapon k/h (KPH, kills per hit)<br>
Weapon accuracy<br><br>

Strict Mode: A player is considered cheating if he has 4 suspicious stats or 1 IMPOSSIBLE stat.<br>
Normal Mode: A player is considered cheating if he has 5 suspicious stats or 1 IMPOSSIBLE stat and 1 suspicious stat.<br>
Example:
<pre><code>
1:  [10:10:13 19] CD - IMPOSSIBLE STATS: Mong0lFPS M60 k/h: 100% (5,01)
    [10:10:13 19] CD - IMPOSSIBLE STATS: Mong0lFPS M60 k/m: 18,22 (16,71)
    [10:10:13 19] CD - IMPOSSIBLE STATS: Mong0lFPS M240 k/h: 100% (4,98)
    [10:10:13 21] CD - IMPOSSIBLE STATS: Mong0lFPS M240 k/m: 15,81 (14,64)
5:  [10:10:13 26] CD - IMPOSSIBLE STATS: Mong0lFPS spm: 9475,55
    [10:10:13 26] CD - SUSPECTED CHEATING: Mong0lFPS 99%
    [10:10:13 26] ------------------------
    [10:10:43 46] CD - suspicious stats: Kershalt007 Pecheneg hs/k: 67,69% (2,77)
    [10:10:43 46] CD - IMPOSSIBLE STATS: Kershalt007 Pecheneg k/m: 10,44 (8,7)
10: [10:10:43 47] CD - suspicious stats: Kershalt007 M60 hs/k: 74,26% (3,06)
    [10:10:43 47] CD - IMPOSSIBLE STATS: Kershalt007 M60 k/m: 10,76 (9,88)
    [10:10:43 47] CD - suspicious stats: Kershalt007 M27 hs/k: 72,02% (2,97)
    [10:10:43 47] CD - suspicious stats: Kershalt007 XP2 LSAT hs/k: 69,3% (3,15)
    [10:10:43 50] CD - SUSPECTED CHEATING: Kershalt007 99%
15: [10:10:43 50] ------------------------
    [10:11:14 59] CD - IMPOSSIBLE STATS: UMadPanda PDR hs/k: 137,36% (6,53)
    [10:11:14 60] CD - IMPOSSIBLE STATS: UMadPanda Taurus 44 hs/k: 163,16% (6,7)
    [10:11:14 60] CD - IMPOSSIBLE STATS: UMadPanda F2000 hs/k: 125,06% (5,28)
    [10:11:14 60] CD - IMPOSSIBLE STATS: UMadPanda P90 hs/k: 87,93% (4,4)
20: [10:11:14 65] CD - SUSPECTED CHEATING: UMadPanda 99%
    [10:11:14 65] ------------------------
</code></pre>
<br>
As you can see in the first line, the weapon ""M60"" on the player ""Mong0lFPS"" has a ""k/h"" (kills per hit ratio) of 100% (422 hits, 422 kills), which is 5,01 times higher than the average k/h on the M60. This is considered impossible.<br>
Line 6 shows the summary of all checks for the player ""Mong0lFPS"". 99% cheating so this player would be kicked/banned or an admin notified.<br>
Weapons with more headshots than kills (except shotguns, rockets and the like) and more than 20 kills will be treated as IMPOSSIBLE (=cheating).<br><br>
</p>

<h3>Live Check</h3>
<p>
From version 0.4 CheatDetector features a Live Protection.<br>
Every 5 minutes all players (except players in the whitelist) will be checked for their headshots per kills (hs/k) and kills per minute (kpm) during their time on your server.<br>
A player is considered cheating if he has > 91% hs/k or > 8 kpm with at least 20 kills. This is basically (average over all weapons) the same limit CheatDetector uses for Stats Check.<br>
Note that Live Check does not distinguish between weapons or vehicles. (This is not reported by the game server)<br>
Example:
<pre><code>
[16:15:02] CD - LiveCheck SUSPECTED CHEATING OMonkeyOoOoOo kills: 30 hs: 30 time: 9,59 hs/k: 100% kpm: 3,12
</code></pre>
<br>
If 0. Enable Live Check is set to ""Yes"" this player will be kicked (or banned, depending on your settings).<br>
For the message displayed to the kicked player %suspiciousstat% will be replaced with ""too many hs/k or k/min (CD - LiveCheck)"" instead of a certain weapon.<br>
This will protect your server from cheaters with clean (or resetted) stats. You can see the checks for non-cheaters on debug level >=3.<br><br>
</p>

<h3>Stream players to 247FairPlay.com</h3>
<p>
http://www.247FairPlay.com is a website providing stats, forum and ban appeal for my server and my bans.<br>
Since version 0.4 you can stream the players on your server to a database at 247FairPlay.com. This DB will be used to check the players in addition to the CheatDetector plugin on your server. The plugin will not be blocked by this and errors (for example: you cant reach 247fairplay.com) wont show up in the log. its ""fire and forget"".<br>
If enabled CheatDetector will contact 247FairPlay.com every 30 minutes. You can see the requests on debug level >=3.<br>
These checks include extended stats check, linked accounts, history check to name just a few (note that some of these features are still in development)<br>
Detected cheater will be banned through the metabans.com account @CheatDetector (http://metabans.com/CheatDetector)<br><br>

How do you make use of these checks? Simple: install metabans plugin and follow @CheatDetector to enforce the bans on the detected cheaters. Depending on the usage (and several more restrictions), it might take some time to get checks done.<br><br>

You will find further information about the new CheatDetector features in the CheatDetector thread at Procon forums, at 247FairPlay.com forum or here as it develops :-)<br><br>
</p>

<h2>THANK YOU</h2>
THX & Credits go to the following people (and more i'm sure):<br>
all Procon Devs for Procon and their API :-)<br>
i-stats.net & symthic.com & bf3stats & cheatometer for their massive DBs of weapon and player values and known cheaters<br>
Panther for showing how to use that API and other Plugin stuff<br>
Phil & Phogue & MorpheusX for all their support and tips and letting me nag em :-)<br>
EBastard & HexaCanon & PapaCharlie & ty_ger & dyn & IAF SDS & all the other for testing, reporting & various tips<br>
Big thx again to PapaCharlie for showing me how to use the Battlelog Cache<br><br>

<h2>Support & Feedback</h2>
<a href=""http://www.phogue.net/forumvb/showthread.php?5414-CheatDetector-%28CD%29"" target=_blank>http://www.phogue.net/forumvb/showthread.php?5414-CheatDetector-(CD)</a>
<h2>Plugin (recommended) Settings</h2>
<blockquote>
0. Ban Method and Whitelist and BattlelogCache<br>
TempBan/Ban by name: Not recommended. A Player can easily change their name and join again. (No)<br>
TempBan/Ban by EA GUID: Recommended. This ID is linked to the player's EA account. Works best with Metabans (Yes)<br>
TempBan/Ban by PB GUID: Recommended. This ID is linked to the player's cd key (No)<br>
Whitelist: List of players (ingame-names without clantag) not to check<br>
Include ReservedSlots/ServerVIPs: Automatically include the players in the ReservedSlot list (Yes)<br>
Exclude Non-ReservedSlots/ServerVIPs: Automatically exclude the players not in the ReservedSlot list (Yes)<br>
Use BattlelogCache if available: Use the Battlelog Cache to reduce traffic (Yes)<br>
Stream Players to 247FairPlay.com: If enabled CheatDetector will contact http://www.247fairplay.com/cheatdetector.php every 30 minutes to add the players on your server to a database to do stats checks and various other checks. If a cheater is detected, he will be banned through the MetaBans Account @CheatDetector (http://metabans.com/CheatDetector). (Yes)<br>
Enable Stats Check: Enable the stats check through battlelog. (Yes)<br>
Enable Strict Mode: When enabled: 1 IMPOSSIBLE or 4 suspicious stats is considered cheating (=kick/ban). When set to NO: 1 IMPOSSIBLE and 1 suspicous or 5 suspicious stats is considered cheating. (NO)<br>
Enable Live Check: Enable the ckecking of the players hs/k and kpm on your server. (Yes)<br><br>

2. Kick<br>
Enable Kick: No<br>
Message to be displayed to the kicked player: %playername% will be replaced with the players name. %pbguid% will be replaced with the players PunkBuster GUID. %eaguid% will be replaced with the players EA GUID. %suspiciousstat% will be replaced with the most significant detected stat. (SUSPECTED CHEATING: %playername% %suspiciousstat%)<br><br>

3. TBan<br>
Enable Temp: If temp ban is enabled, no kick will happen (Yes)<br>
Message to be displayed to the temp banned player: %playername% will be replaced with the players name. %pbguid% will be replaced with the players PunkBuster GUID. %eaguid% will be replaced with the players EA GUID. %suspiciousstat% will be replaced with the most significant detected stat. (SUSPECTED CHEATING: %playername% %suspiciousstat%)<br>
Length of Temp Ban (min): Length of temp ban in minutes (15)<br><br>

4. Ban<br>
Enable ban: If permanent ban is enabled, no temp ban or kick will happen (No)<br>
Message to be displayed to the banned player: %playername% will be replaced with the players name. %pbguid% will be replaced with the players PunkBuster GUID. %eaguid% will be replaced with the players EA GUID. %suspiciousstat% will be replaced with the most significant detected stat. (SUSPECTED CHEATING: %playername% %suspiciousstat%)<br><br>

5. Notify<br>
Enable ingame notification: Yell a message to an admin (or any other player) when a player is detected by this plugin (Yes)<br>
Ingame username: player to receive the ingame notification via pyell<br>
Time to display (sec): Time to display the ingame notification in seconds (30)<br><br>

6. Debug<br>
Debug Level (0-5): Debug level adjusting how many debug messages you will see in the plugin console log (1)<br>
0 - no messages at all (quiet)<br>
1 - only detections/kicks/bans will be displayed<br>
2 - will also show log entries for normal players and some queue timeout operation when neccessary<br>
3 - will also show the queue size and number of players enqueued, adding and removing of players to the playerlist and queue, skipping of whitelisted players, queue timeout operations<br>
4 - will also show checked and skipped weapons, a lot more internal operations, ""expected"" errors (dont worry ;-))<br>
5 - just for development and testing<br><br>
Log to file: Log plugin output to a file (CDLogFile.txt) in the Plugin/BF3 directory. Not recommended, this file may get very big and slow your procon down. Only use it to log errors and only use it local (No)<br>
Filename/Path: Filename and path of the logfile relative to the Procon executable (Plugins/BF3/PBSSELogFile.txt)<br>
Advanced: DO NOT PLAY WITH THESE VALUES UNLESS INSTRUCTED BY ME OR YOU WILL BREAK THE PLUGIN (NO)<br>
</blockquote>

<h2>Version History (Changelog):</h2>
<blockquote>
<h4>0.4.2</h4>
-NEW: Settings: Enable Strict Mode (When enabled: 1 IMPOSSIBLE or 4 suspicious stats is considered cheating (=kick/ban). When set to NO: 1 IMPOSSIBLE and 1 suspicous or 5 suspicious stats is considered cheating.)<br>
-FIX: More headshots than kills are only considered IMPOSSIBLE (or suspicious) if they exceed the average by 320% (270%). See https://forum.myrcon.com/showthread.php?5414-CheatDetector-(CD)&p=75230&viewfull=1#post75230.<br><br>
<h4>0.4.1</h4>
-FIX: Increased minimum kills needed for weapons with more headshots than kills back to 130.<br><br>
<h4>0.4</h4>
-NEW: Live Check: CheatDetector will now monitor the players on your server for headshots per kills and kills per minute. Cheating is considered >91% HS/K or >8 KPM with more than 20 kills. A check is made every 5 minutes. Whitelist and messages apply here too. (0. Ban Method and Whitelist and BattlelogCache -> Enable Live Check)<br>
-NEW: Stream Players to 247FairPlay.com: If enabled CheatDetector will contact http://www.247fairplay.com/cheatdetector.php every 30 minutes to add the players on your server to a database (the plugin will not be blocked by this and errors (for example: you cant reach 247fairplay.com) wont show up in the log. its ""fire and forget""). This DB will be used to do stats checks and various other checks. If a cheater is detected, he will be banned through the MetaBans Account @CheatDetector (http://metabans.com/CheatDetector).<br>
-FIX: Stats Check: Weapons with more headshots than kills (except shotguns, rockets and the like) and more than 20 kills will be treated as IMPOSSIBLE (=cheating).<br>
-NEW: Settings: Enable Live Check.<br>
-NEW: Settings: Enable Stats Check.<br>
-NEW: Settings: Stream Players to 247FairPlay.com<br>
-NEW: Settings: Exclude Non-ReservedSlots/ServerVIPs: will automatically remove players from the plugins whitelist that are not in your ReservedSlots List<br>
-FIX: Several internal code improvements.<br><br>
<h4>0.3</h4>
-NEW: You can now use Battlelog Cache to reduce traffic. (0. Ban Method and Whitelist and BattlelogCache -> Use BattlelogCache if available)<br>
-FIX: The Output on certain debug levels have been adjusted to be not so spamming.<br>
-FIX: 2 Typos in Weapon Names have been fixed (M1911 Tactical) which caused this weapon to not be analyzed for k/h and k/m.<br>
-FIX: Under certain circumtances endless ingame notification could happen. This is now fixed.<br>
-FIX: When a player is banned (TBan and Ban) a Kick will make sure the player is gone.<br>
-FIX: Added placeholders %pbguid% and %eaguid% to the messages.<br>
-FIX: Increased the max TBan time to 100 years (was 1 year), but you might as well use permanent there :-)<br>
-FIX: Several internal code improvements.<br><br>
<h4>0.2.1</h4>
-NEW: You can now setup the ingame notification (4. Notify) in detail.<br>
-FIX: Tiny update to the scores to find the best reason (most suspicious/impossible stat) to be used in various messages.<br>
-FIX: SPM is now only taken into account if the playtime is above 1 hour.<br>
-FIX: small code updates.<br><br>
<h4>0.2</h4>
-UPDATE: You can now download/update CheatDetector directly through your procon gui.<br><br>
<h4>0.1.2</h4>
-FIX: The plugin will now automatically detect when the BF3 Battlelog Request Limit is reached. Then it will increase the queue timeout. The timeout will then be decreased step by step to normal.<br>
-FIX: An error happened when there were multiple detections with the same score. This is now fixed<br>
-FIX: not that important error messages are now displayed properly (Debug level 2, 3, 4)<br><br>
<h4>0.1.1</h4>
-FIX: Plugin now identifies itself properly to Battlelog<br>
-NEW: Option to add multiple usernames to get notified (4. Notify -> ingame username)<br><br>
<h4>0.1</h4>
-Public release
</blockquote>
<h2>Known Issues</h2>
<blockquote>
<h4>Cheat Detection</h4>
Since this plugin tries to detect cheaters using their BF3 Battlelog stats, it is limited to that data. If a cheater got his stats reset, there is no way for this plugin (as of now) to detect the cheater.<br>
On the other hand, this plugin might detect someone as a cheater who is not cheating.<br>
Workaround (cheater not detected): None. Inform me about this issue. Maybe i will add other data sources for cheat detection in the future.<br>
Workaround (normal player detected as cheater): Add this player to your whitelist and inform me about this false positive.<br><br>
<h4>Whitelist</h4>
If you add a player to your ReservedSlots/ServerVIP List they might not show up in the whitelist setting immediately. However you can be sure they are added and processed. I think this is because Procon GUI does not reload the setting when its not changed in the GUI. Just reopen the Plugins Tab and they should be displayed. Or restart Procon on your PC (NOT the layer server, just the exe on your PC) and they will show up.<br>
Workaround: Not really needed, however if someone knows a solution i would like to know it too :-)<br><br>
<h4>Logfile</h4>
This file may get very big and slow your procon down. Only use it to log errors and only use it local. The directory must also exist and be writeable by your procon.
</blockquote>
";
        }

        public void OnPluginLoaded(string strHostName, string strPort, string strPRoConVersion)
        {
            RegisterEvents(GetType().Name,
                "OnListPlayers",
                "OnPlayerLeft",
                "OnReservedSlotsList",
                "OnLevelLoaded",
                "OnPunkbusterPlayerInfo",
                "OnPlayerKilled"
                );
        }

        public void OnPluginEnable()
        {
            ExecuteCommand("procon.protected.pluginconsole.write", "^bCheatDetector ^2Enabled!");
            IsCacheEnabled(true);
        }

        public void OnPluginDisable()
        {
            ExecuteCommand("procon.protected.pluginconsole.write", "^bCheatDetector ^1Disabled =(");
        }

        public void OnLevelLoaded(string mapFileName, string Gamemode, int roundsPlayed, int roundsTotal)
        {
            if (SyncResetListsHelper > 3)
            {
                SyncResetPlayerLists = true;
                SyncResetListsHelper = 0;
            }
            else
            {
                SyncResetListsHelper++;
            }
        }
        #endregion

        #region settings read
        public List<CPluginVariable> GetDisplayPluginVariables()
        {
            List<CPluginVariable> lstReturn = new List<CPluginVariable>();

            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|TempBan/Ban by name", typeof(enumBoolYesNo), banbyname));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|TempBan/Ban by EA GUID", typeof(enumBoolYesNo), banbyeaguid));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|TempBan/Ban by PB GUID", typeof(enumBoolYesNo), banbypbguid));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Whitelist", typeof(string[]), whitelist.ToArray()));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Include ReservedSlots/ServerVIPs", typeof(enumBoolYesNo), includereservedslots));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Exclude Non-ReservedSlots/ServerVIPs", typeof(enumBoolYesNo), excludereservedslots));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Use BattlelogCache if available", typeof(enumBoolYesNo), useCache));
            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Stream Players to 247FairPlay.com", typeof(enumBoolYesNo), publicintegration));

            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Enable Stats Check", typeof(enumBoolYesNo), DoStatsCheck));
            if (DoStatsCheck == enumBoolYesNo.Yes)
                lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Enable Strict Mode", typeof(enumBoolYesNo), strictmode));

            lstReturn.Add(new CPluginVariable("0. Ban Method and Whitelist and BattlelogCache|Enable Live Check", typeof(enumBoolYesNo), DoLiveCheck));
            
            lstReturn.Add(new CPluginVariable("1. Kick|Enable Kick", typeof(enumBoolYesNo), enablekick));
            if (enablekick == enumBoolYesNo.Yes)
                lstReturn.Add(new CPluginVariable("1. Kick|Message to be displayed to the kicked player", kicktext.GetType(), kicktext));

            lstReturn.Add(new CPluginVariable("2. TBan|Enable Temp Ban", typeof(enumBoolYesNo), enabletban));
            if (enabletban == enumBoolYesNo.Yes)
            {
                lstReturn.Add(new CPluginVariable("2. TBan|Message to be displayed to the temp banned player", tbantext.GetType(), tbantext));
                lstReturn.Add(new CPluginVariable("2. TBan|Length of Temp Ban (min)", tbantime.GetType(), tbantime));
            }

            lstReturn.Add(new CPluginVariable("3. Ban|Enable Ban", typeof(enumBoolYesNo), enableban));
            if (enableban == enumBoolYesNo.Yes)
                lstReturn.Add(new CPluginVariable("3. Ban|Message to be displayed to the banned player", bantext.GetType(), bantext));

            lstReturn.Add(new CPluginVariable("4. Notify|Enable ingame notification", typeof(enumBoolYesNo), enableingamenotify));
            if (enableingamenotify == enumBoolYesNo.Yes)
            {
                lstReturn.Add(new CPluginVariable("4. Notify|Enable public ingame notification say", typeof(enumBoolYesNo), enableingamepubnotifysay));
                if (enableingamepubnotifysay == enumBoolYesNo.Yes)
                    lstReturn.Add(new CPluginVariable("4. Notify|Message to be displayed (say)", publicnotifysaytext.GetType(), publicnotifysaytext));
                lstReturn.Add(new CPluginVariable("4. Notify|Enable public ingame notification yell", typeof(enumBoolYesNo), enableingamepubnotifyyell));
                if (enableingamepubnotifyyell == enumBoolYesNo.Yes)
                {
                    lstReturn.Add(new CPluginVariable("4. Notify|Time to display (sec) (yell)", ingamepublicnotifytime.GetType(), ingamepublicnotifytime));
                    lstReturn.Add(new CPluginVariable("4. Notify|Message to be displayed (yell)", publicnotifyyelltext.GetType(), publicnotifyyelltext));
                }
                lstReturn.Add(new CPluginVariable("4. Notify|Enable private ingame notification psay", typeof(enumBoolYesNo), enableingameprivpsay));
                if (enableingameprivpsay == enumBoolYesNo.Yes)
                {
                    lstReturn.Add(new CPluginVariable("4. Notify|Ingame username (psay)", typeof(string[]), ingameaccountnamepsay.ToArray()));
                    lstReturn.Add(new CPluginVariable("4. Notify|Message to be displayed (psay)", privatenotifypsaytext.GetType(), privatenotifypsaytext));
                }
                lstReturn.Add(new CPluginVariable("4. Notify|Enable private ingame notification pyell", typeof(enumBoolYesNo), enableingameprivpyell));
                if (enableingameprivpyell == enumBoolYesNo.Yes)
                {
                    lstReturn.Add(new CPluginVariable("4. Notify|Time to display (sec) (pyell)", ingameprivnotifytime.GetType(), ingameprivnotifytime));
                    lstReturn.Add(new CPluginVariable("4. Notify|Ingame username (pyell)", typeof(string[]), ingameaccountnamepyell.ToArray()));
                    lstReturn.Add(new CPluginVariable("4. Notify|Message to be displayed (pyell)", privatenotifypyelltext.GetType(), privatenotifypyelltext));
                }
            }

            lstReturn.Add(new CPluginVariable("5. Debug|Debug Level (0-5)", debuglevel.GetType(), debuglevel));
            lstReturn.Add(new CPluginVariable("5. Debug|Log to file", typeof(enumBoolYesNo), logtofile));
            if (logtofile == enumBoolYesNo.Yes)
                lstReturn.Add(new CPluginVariable("5. Debug|Filename/Path", logfilename.GetType(), logfilename));

            lstReturn.Add(new CPluginVariable("5. Debug|Advanced", typeof(enumBoolYesNo), advanced));
            if (advanced == enumBoolYesNo.Yes)
            {
                lstReturn.Add(new CPluginVariable("5. Debug|Lazy Queue", typeof(enumBoolYesNo), lazyQueue));
                //lstReturn.Add(new CPluginVariable("6. Debug|Yellow Flag Accuracy", yellowacc.GetType(), yellowacc));
                //lstReturn.Add(new CPluginVariable("5. Debug|Orange Flag Accuracy", orangeacc.GetType(), orangeacc));
                //lstReturn.Add(new CPluginVariable("5. Debug|Red Flag Accuracy", redacc.GetType(), redacc));
                //lstReturn.Add(new CPluginVariable("6. Debug|Yellow Flag Headshots per Kill", yellowhspk.GetType(), yellowhspk));
                //lstReturn.Add(new CPluginVariable("5. Debug|Orange Flag Headshots per Kill", orangehspk.GetType(), orangehspk));
                //lstReturn.Add(new CPluginVariable("5. Debug|Red Flag Headshots per Kill", redhspk.GetType(), redhspk));
                //lstReturn.Add(new CPluginVariable("6. Debug|Yellow Flag Kills per Hit", yellowkph.GetType(), yellowkph));
                //lstReturn.Add(new CPluginVariable("5. Debug|Orange Flag Kills per Hit", orangekph.GetType(), orangekph));
                //lstReturn.Add(new CPluginVariable("5. Debug|Red Flag Kills per Hit", redkph.GetType(), redkph));
                //lstReturn.Add(new CPluginVariable("5. Debug|Orange Flag Kills per Min", orangekpm.GetType(), orangekpm));
                //lstReturn.Add(new CPluginVariable("5. Debug|Red Flag Kills per Min", redkpm.GetType(), redkpm));
                lstReturn.Add(new CPluginVariable("5. Debug|Orange Flag Score per Min", orangespm.GetType(), orangespm));
                lstReturn.Add(new CPluginVariable("5. Debug|Red Flag Score per Min", redspm.GetType(), redspm));
                lstReturn.Add(new CPluginVariable("5. Debug|Min Kills", minkills.GetType(), minkills));
                lstReturn.Add(new CPluginVariable("5. Debug|Min Kills Live", minkillslive.GetType(), minkillslive));
                lstReturn.Add(new CPluginVariable("5. Debug|Max hsklive", maxhsklive.GetType(), maxhsklive));
                lstReturn.Add(new CPluginVariable("5. Debug|Max kmlive", maxkmlive.GetType(), maxkmlive));
                lstReturn.Add(new CPluginVariable("5. Debug|Name", typeof(string[]), tempplayertocheck.ToArray()));
                lstReturn.Add(new CPluginVariable("5. Debug|Test", typeof(enumBoolYesNo), test));
                lstReturn.Add(new CPluginVariable("5. Debug|Retries", retries.GetType(), retries));                
                lstReturn.Add(new CPluginVariable("5. Debug|Timeout Test", typeof(enumBoolYesNo), timeouttest));
                lstReturn.Add(new CPluginVariable("5. Debug|Stream to Master", typeof(enumBoolYesNo), streamtomaster));

                if (streamtomaster == enumBoolYesNo.Yes)
                {
                    lstReturn.Add(new CPluginVariable("5. Debug|Server", queueServer.GetType(), queueServer));
                    lstReturn.Add(new CPluginVariable("5. Debug|DB", queueDB.GetType(), queueDB));
                    lstReturn.Add(new CPluginVariable("5. Debug|User", queueUser.GetType(), queueUser));
                    lstReturn.Add(new CPluginVariable("5. Debug|Pass", queuePwd.GetType(), queuePwd));
                    lstReturn.Add(new CPluginVariable("5. Debug|Connect", typeof(enumBoolYesNo), DoConnect));                    
                }
            }

            return lstReturn;
        }

        public List<CPluginVariable> GetPluginVariables()
        {
            List<CPluginVariable> lstReturn = new List<CPluginVariable>();

            lstReturn.Add(new CPluginVariable("TempBan/Ban by name", typeof(enumBoolYesNo), banbyname));
            lstReturn.Add(new CPluginVariable("TempBan/Ban by EA GUID", typeof(enumBoolYesNo), banbyeaguid));
            lstReturn.Add(new CPluginVariable("TempBan/Ban by PB GUID", typeof(enumBoolYesNo), banbypbguid));
            lstReturn.Add(new CPluginVariable("Whitelist", typeof(string[]), whitelist.ToArray()));
            lstReturn.Add(new CPluginVariable("Include ReservedSlots/ServerVIPs", typeof(enumBoolYesNo), includereservedslots));
            lstReturn.Add(new CPluginVariable("Exclude Non-ReservedSlots/ServerVIPs", typeof(enumBoolYesNo), excludereservedslots));
            lstReturn.Add(new CPluginVariable("Use BattlelogCache if available", typeof(enumBoolYesNo), useCache));
            lstReturn.Add(new CPluginVariable("Stream Players to 247FairPlay.com", typeof(enumBoolYesNo), publicintegration));

            lstReturn.Add(new CPluginVariable("Enable Stats Check", typeof(enumBoolYesNo), DoStatsCheck));
            lstReturn.Add(new CPluginVariable("Enable Strict Mode", typeof(enumBoolYesNo), strictmode));

            lstReturn.Add(new CPluginVariable("Enable Live Check", typeof(enumBoolYesNo), DoLiveCheck));
            
            lstReturn.Add(new CPluginVariable("Enable Kick", typeof(enumBoolYesNo), enablekick));
            lstReturn.Add(new CPluginVariable("Message to be displayed to the kicked player", kicktext.GetType(), kicktext));

            lstReturn.Add(new CPluginVariable("Enable Temp Ban", typeof(enumBoolYesNo), enabletban));
            lstReturn.Add(new CPluginVariable("Message to be displayed to the temp banned player", tbantext.GetType(), tbantext));
            lstReturn.Add(new CPluginVariable("Length of Temp Ban (min)", tbantime.GetType(), tbantime));

            lstReturn.Add(new CPluginVariable("Enable Ban", typeof(enumBoolYesNo), enableban));
            lstReturn.Add(new CPluginVariable("Message to be displayed to the banned player", bantext.GetType(), bantext));

            lstReturn.Add(new CPluginVariable("Enable ingame notification", typeof(enumBoolYesNo), enableingamenotify));
            lstReturn.Add(new CPluginVariable("Enable public ingame notification say", typeof(enumBoolYesNo), enableingamepubnotifysay));
            lstReturn.Add(new CPluginVariable("Message to be displayed (say)", publicnotifysaytext.GetType(), publicnotifysaytext));
            lstReturn.Add(new CPluginVariable("Enable public ingame notification yell", typeof(enumBoolYesNo), enableingamepubnotifyyell));
            lstReturn.Add(new CPluginVariable("Time to display (sec) (yell)", ingamepublicnotifytime.GetType(), ingamepublicnotifytime));
            lstReturn.Add(new CPluginVariable("Message to be displayed (yell)", publicnotifyyelltext.GetType(), publicnotifyyelltext));

            lstReturn.Add(new CPluginVariable("Enable private ingame notification psay", typeof(enumBoolYesNo), enableingameprivpsay));
            lstReturn.Add(new CPluginVariable("Ingame username (psay)", typeof(string[]), ingameaccountnamepsay.ToArray()));
            lstReturn.Add(new CPluginVariable("Message to be displayed (psay)", privatenotifypsaytext.GetType(), privatenotifypsaytext));

            lstReturn.Add(new CPluginVariable("Enable private ingame notification pyell", typeof(enumBoolYesNo), enableingameprivpyell));
            lstReturn.Add(new CPluginVariable("Time to display (sec) (pyell)", ingameprivnotifytime.GetType(), ingameprivnotifytime));
            lstReturn.Add(new CPluginVariable("Ingame username (pyell)", typeof(string[]), ingameaccountnamepyell.ToArray()));
            lstReturn.Add(new CPluginVariable("Message to be displayed (pyell)", privatenotifypyelltext.GetType(), privatenotifypyelltext));

            lstReturn.Add(new CPluginVariable("Debug Level (0-5)", debuglevel.GetType(), debuglevel));
            lstReturn.Add(new CPluginVariable("Log to file", typeof(enumBoolYesNo), logtofile));
            lstReturn.Add(new CPluginVariable("Filename/Path", logfilename.GetType(), logfilename));
            lstReturn.Add(new CPluginVariable("Advanced", typeof(enumBoolYesNo), advanced));
            lstReturn.Add(new CPluginVariable("Lazy Queue", typeof(enumBoolYesNo), lazyQueue));
            //lstReturn.Add(new CPluginVariable("Yellow Flag Accuracy", yellowacc.GetType(), yellowacc));
            //lstReturn.Add(new CPluginVariable("Orange Flag Accuracy", orangeacc.GetType(), orangeacc));
            //lstReturn.Add(new CPluginVariable("Red Flag Accuracy", redacc.GetType(), redacc));
            //lstReturn.Add(new CPluginVariable("Yellow Flag Headshots per Kill", yellowhspk.GetType(), yellowhspk));
            //lstReturn.Add(new CPluginVariable("Orange Flag Headshots per Kill", orangehspk.GetType(), orangehspk));
            //lstReturn.Add(new CPluginVariable("Red Flag Headshots per Kill", redhspk.GetType(), redhspk));
            //lstReturn.Add(new CPluginVariable("Yellow Flag Kills per Hit", yellowkph.GetType(), yellowkph));
            //lstReturn.Add(new CPluginVariable("Orange Flag Kills per Hit", orangekph.GetType(), orangekph));
            //lstReturn.Add(new CPluginVariable("Red Flag Kills per Hit", redkph.GetType(), redkph));
            //lstReturn.Add(new CPluginVariable("Orange Flag Kills per Min", orangekpm.GetType(), orangekpm));
            //lstReturn.Add(new CPluginVariable("Red Flag Kills per Min", redkpm.GetType(), redkpm));
            lstReturn.Add(new CPluginVariable("Orange Flag Score per Min", orangespm.GetType(), orangespm));
            lstReturn.Add(new CPluginVariable("Red Flag Score per Min", redspm.GetType(), redspm));
            lstReturn.Add(new CPluginVariable("Min Kills", minkills.GetType(), minkills));
            lstReturn.Add(new CPluginVariable("Min Kills Live", minkillslive.GetType(), minkillslive));
            lstReturn.Add(new CPluginVariable("Max hsklive", maxhsklive.GetType(), maxhsklive));
            lstReturn.Add(new CPluginVariable("Max kmlive", maxkmlive.GetType(), maxkmlive));
            lstReturn.Add(new CPluginVariable("Name", typeof(string[]), tempplayertocheck.ToArray()));
            lstReturn.Add(new CPluginVariable("Test", typeof(enumBoolYesNo), test));
            lstReturn.Add(new CPluginVariable("Retries", retries.GetType(), retries));
            lstReturn.Add(new CPluginVariable("Timeout Test", typeof(enumBoolYesNo), timeouttest));
            lstReturn.Add(new CPluginVariable("Stream to Master", typeof(enumBoolYesNo), streamtomaster));

            if (streamtomaster == enumBoolYesNo.Yes)
            {
                lstReturn.Add(new CPluginVariable("Server", queueServer.GetType(), queueServer));
                lstReturn.Add(new CPluginVariable("DB", queueDB.GetType(), queueDB));
                lstReturn.Add(new CPluginVariable("User", queueUser.GetType(), queueUser));
                lstReturn.Add(new CPluginVariable("Pass", queuePwd.GetType(), queuePwd));
                lstReturn.Add(new CPluginVariable("Connect", typeof(enumBoolYesNo), DoConnect));                
            }

            return lstReturn;
        }
        #endregion

        #region settings write
        public void SetPluginVariable(string strVariable, string strValue)
        {
            int outvalue;
            //uint uoutvalue;
            double outvaluedouble;

            if (strVariable.CompareTo("Whitelist") == 0)
            {
                whitelist = new List<string>(strValue.Split(new char[] { '|' }));
            }
            else if (strVariable.CompareTo("Include ReservedSlots/ServerVIPs") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                includereservedslots = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                ExecuteCommand("procon.protected.send", "reservedSlotsList.list");
            }
            else if (strVariable.CompareTo("Enable Strict Mode") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                strictmode = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);                
            }
            else if (strVariable.CompareTo("Exclude Non-ReservedSlots/ServerVIPs") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                excludereservedslots = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                ExecuteCommand("procon.protected.send", "reservedSlotsList.list");
            }
            else if (strVariable.CompareTo("Use BattlelogCache if available") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                useCache = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Stream Players to 247FairPlay.com") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                publicintegration = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable Stats Check") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                DoStatsCheck = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable Live Check") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                DoLiveCheck = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("TempBan/Ban by name") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                banbyname = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (banbyname == enumBoolYesNo.Yes)
                {
                    banbyeaguid = enumBoolYesNo.No;
                    banbypbguid = enumBoolYesNo.No;
                }
            }
            else if (strVariable.CompareTo("TempBan/Ban by EA GUID") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                banbyeaguid = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (banbyeaguid == enumBoolYesNo.Yes)
                {
                    banbyname = enumBoolYesNo.No;
                    banbypbguid = enumBoolYesNo.No;
                }
            }
            else if (strVariable.CompareTo("TempBan/Ban by PB GUID") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                banbypbguid = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (banbypbguid == enumBoolYesNo.Yes)
                {
                    banbyname = enumBoolYesNo.No;
                    banbyeaguid = enumBoolYesNo.No;
                }
            }
            else if (strVariable.CompareTo("Name") == 0)
            {
                tempplayertocheck = new List<string>(strValue.Split(new char[] { '|' }));
            }
            else if (strVariable.CompareTo("Test") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                test = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Timeout Test") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                timeouttest = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable Kick") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enablekick = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (enablekick == enumBoolYesNo.Yes)
                {
                    enabletban = enumBoolYesNo.No;
                    enableban = enumBoolYesNo.No;
                }
            }
            else if (strVariable.CompareTo("Enable Temp Ban") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enabletban = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (enabletban == enumBoolYesNo.Yes)
                {
                    enablekick = enumBoolYesNo.No;
                    enableban = enumBoolYesNo.No;
                }
            }
            else if (strVariable.CompareTo("Enable Ban") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enableban = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (enableban == enumBoolYesNo.Yes)
                {
                    enabletban = enumBoolYesNo.No;
                    enablekick = enumBoolYesNo.No;
                }
            }
            else if (strVariable.CompareTo("Length of Temp Ban (min)") == 0 && int.TryParse(strValue, out outvalue))
            {
                tbantime = outvalue;

                if (tbantime < 0) //not less than 0
                {
                    tbantime = 0;
                }
                if (tbantime > 53568000)
                {
                    tbantime = 53568000;
                }
            }
            else if (strVariable.CompareTo("Message to be displayed to the kicked player") == 0)
            {
                kicktext = strValue;
            }
            else if (strVariable.CompareTo("Message to be displayed to the temp banned player") == 0)
            {
                tbantext = strValue;
            }
            else if (strVariable.CompareTo("Message to be displayed to the banned player") == 0)
            {
                bantext = strValue;
            }
            else if (strVariable.CompareTo("Message to be displayed (say)") == 0)
            {
                publicnotifysaytext = strValue;
            }
            else if (strVariable.CompareTo("Message to be displayed (yell)") == 0)
            {
                publicnotifyyelltext = strValue;
            }
            else if (strVariable.CompareTo("Message to be displayed (psay)") == 0)
            {
                privatenotifypsaytext = strValue;
            }
            else if (strVariable.CompareTo("Message to be displayed (pyell)") == 0)
            {
                privatenotifypyelltext = strValue;
            }
            else if (strVariable.CompareTo("Enable ingame notification") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enableingamenotify = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable public ingame notification say") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enableingamepubnotifysay = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable public ingame notification yell") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enableingamepubnotifyyell = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable private ingame notification psay") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enableingameprivpsay = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Enable private ingame notification pyell") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                enableingameprivpyell = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Ingame username (psay)") == 0)
            {
                ingameaccountnamepsay = new List<string>(strValue.Split(new char[] { '|' }));
            }
            else if (strVariable.CompareTo("Ingame username (pyell)") == 0)
            {
                ingameaccountnamepyell = new List<string>(strValue.Split(new char[] { '|' }));
            }
            else if (strVariable.CompareTo("Time to display (sec) (pyell)") == 0 && int.TryParse(strValue, out outvalue))
            {
                if (outvalue < 1)
                {
                    outvalue = 1;
                }
                if (outvalue > 120) //120 secs is enough
                {
                    outvalue = 120;
                }
                ingameprivnotifytime = outvalue;
            }
            else if (strVariable.CompareTo("Time to display (sec) (yell)") == 0 && int.TryParse(strValue, out outvalue))
            {
                if (outvalue < 1)
                {
                    outvalue = 1;
                }
                if (outvalue > 120) //120 secs is enough
                {
                    outvalue = 120;
                }
                ingamepublicnotifytime = outvalue;
            }
            else if (strVariable.CompareTo("Debug Level (0-5)") == 0 && int.TryParse(strValue, out outvalue))
            {
                debuglevel = outvalue;
                if (debuglevel < 0)
                {
                    debuglevel = 0;
                }
                if (debuglevel > 5)
                {
                    debuglevel = 5;
                }
            }
            else if (strVariable.CompareTo("Advanced") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                advanced = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Lazy Queue") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                lazyQueue = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            //else if (strVariable.CompareTo("Yellow Flag Accuracy") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    yellowacc = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Orange Flag Accuracy") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    orangeacc = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Red Flag Accuracy") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    redacc = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Yellow Flag Headshots per Kill") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    yellowhspk = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Orange Flag Headshots per Kill") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    orangehspk = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Red Flag Headshots per Kill") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    redhspk = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Yellow Flag Kills per Hit") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    yellowkph = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Orange Flag Kills per Hit") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    orangekph = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Red Flag Kills per Hit") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    redkph = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Orange Flag Kills per Min") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    orangekpm = outvaluedouble;
            //}
            //else if (strVariable.CompareTo("Red Flag Kills per Min") == 0 && double.TryParse(strValue, out outvaluedouble))
            //{
            //    redkpm = outvaluedouble;
            //}
            else if (strVariable.CompareTo("Orange Flag Score per Min") == 0 && double.TryParse(strValue, out outvaluedouble))
            {
                orangespm = outvaluedouble;
            }
            else if (strVariable.CompareTo("Red Flag Score per Min") == 0 && double.TryParse(strValue, out outvaluedouble))
            {
                redspm = outvaluedouble;
            }
            else if (strVariable.CompareTo("Min Kills") == 0 && int.TryParse(strValue, out outvalue))
            {
                minkills = outvalue;
            }
            else if (strVariable.CompareTo("Min Kills Live") == 0 && double.TryParse(strValue, out outvaluedouble))
            {
                minkillslive = outvaluedouble;
            }
            else if (strVariable.CompareTo("Max hsklive") == 0 && double.TryParse(strValue, out outvaluedouble))
            {
                maxhsklive = outvaluedouble;
            }
            else if (strVariable.CompareTo("Max kmlive") == 0 && double.TryParse(strValue, out outvaluedouble))
            {
                maxkmlive = outvaluedouble;
            }
            else if (strVariable.CompareTo("Retries") == 0 && int.TryParse(strValue, out outvalue))
            {
                retries = outvalue;
            }
            else if (strVariable.CompareTo("Log to file") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                logtofile = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Filename/Path") == 0)
            {
                logfilename = strValue;
            }
            else if (strVariable.CompareTo("Stream to Master") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                streamtomaster = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
            }
            else if (strVariable.CompareTo("Server") == 0)
            {
                queueServer = strValue;
            }
            else if (strVariable.CompareTo("DB") == 0)
            {
                queueDB = strValue;
            }
            else if (strVariable.CompareTo("User") == 0)
            {
                queueUser = strValue;
            }
            else if (strVariable.CompareTo("Pass") == 0)
            {
                queuePwd = strValue;
            }
            else if (strVariable.CompareTo("Connect") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
            {
                DoConnect = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
                if (DoConnect == enumBoolYesNo.Yes)
                {
                    DB = new DBConnect(this);
                }
                //else if (DoConnect == enumBoolYesNo.No)
                //{
                //    DB = null;
                //}
            }
        }
        #endregion

        public virtual void OnPlayerKilled(Kill kKillerVictimDetails)
        {
            if (DoLiveCheck == enumBoolYesNo.Yes)
            {
                lock (killlock)
                {
                    if (kKillerVictimDetails.Killer.SoldierName != kKillerVictimDetails.Victim.SoldierName && !kKillerVictimDetails.IsSuicide)
                    {
                        if (!kills.ContainsKey(kKillerVictimDetails.Killer.SoldierName))
                        {
                            kills.Add(kKillerVictimDetails.Killer.SoldierName, 0);
                        }
                        kills[kKillerVictimDetails.Killer.SoldierName]++;

                        if (!hs.ContainsKey(kKillerVictimDetails.Killer.SoldierName))
                        {
                            hs.Add(kKillerVictimDetails.Killer.SoldierName, 0);
                        }

                        if (kKillerVictimDetails.Headshot)
                        {
                            hs[kKillerVictimDetails.Killer.SoldierName]++;
                        }

                        if (!firstkill.ContainsKey(kKillerVictimDetails.Killer.SoldierName))
                        {
                            firstkill.Add(kKillerVictimDetails.Killer.SoldierName, DateTime.Now);
                        }
                    }
                }
            }
        }

        private void livecheck(List<CPlayerInfo> lstPlayers)
        {
            DateTime now = DateTime.Now;

            lock (killlock)
            {
                if (lstPlayers.Count > 0 || debuglevel >= 4)
                {
                    log("CD - LiveCheck -------------------------------", 3);
                }

                try
                {
                    foreach (CPlayerInfo player in lstPlayers)
                    {
                        if (kills.ContainsKey(player.SoldierName) && hs.ContainsKey(player.SoldierName) && firstkill.ContainsKey(player.SoldierName) && !whitelist.Contains(player.SoldierName))
                        {
                            TimeSpan time = now - firstkill[player.SoldierName];

                            log("CD - LiveCheck " + player.SoldierName + " kills: " + kills[player.SoldierName] + " hs: " + hs[player.SoldierName] + " time: " + Math.Round(time.TotalMinutes, 2) + " hs/k: " + Math.Round((hs[player.SoldierName] / kills[player.SoldierName]) * 100, 2) + "% kpm: " + Math.Round(kills[player.SoldierName] / time.TotalMinutes, 2), 3);

                            if (kills[player.SoldierName] > minkillslive)
                            {
                                if (hs[player.SoldierName] / kills[player.SoldierName] > maxhsklive || hs[player.SoldierName] > kills[player.SoldierName] || kills[player.SoldierName] / time.TotalMinutes > maxkmlive)
                                {
                                    log("CD - LiveCheck SUSPECTED CHEATING " + player.SoldierName + " kills: " + kills[player.SoldierName] + " hs: " + hs[player.SoldierName] + " time: " + Math.Round(time.TotalMinutes, 2) + " hs/k: " + Math.Round((hs[player.SoldierName] / kills[player.SoldierName]) * 100, 2) + "% kpm: " + Math.Round(kills[player.SoldierName] / time.TotalMinutes, 2), 1);
                                    punish(player.SoldierName, "too many hs/k or k/min (CD - LiveCheck)");
                                }
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                    log("CD - ERROR: CD.livecheck: " + ex, 1);
                }
            }
        }

        #region checkbatch
        public void checkbatch()
        {
            if (queue.Count > 0)
            {
                log("CD - " + queue.Count.ToString() + " players in check queue", 3);
                for (int i = 0; i < batchsize; i++)
                {
                    log("CD - checking: " + queue[0], 3);
                    if (IsCacheEnabled(false))
                    {
                        checkPlayerCached(queue[0]);
                        log("CD - checkPlayerCached returned", 5);
                    }
                    else
                    {
                        checkPlayer(queue[0]);
                    }
                    queue.RemoveAt(0);

                    if (queue.Count < 1)
                    {
                        break;
                    }
                }
            }
            else
                log("CD - nothing to do", 4);
        }
        #endregion

        #region playerleft
        public virtual void OnPlayerLeft(CPlayerInfo playerInfo)
        {
            if (myplayerlist.Contains(playerInfo.SoldierName))
            {
                log("CD - removing from playerlist (PlayerLeft): " + playerInfo.SoldierName, 4);
                myplayerlist.Remove(playerInfo.SoldierName);
            }
            if (lazyQueue != enumBoolYesNo.Yes)
            {
                if (queue.Contains(playerInfo.SoldierName))
                {
                    log("CD - removing from queue (PlayerLeft): " + playerInfo.SoldierName, 4);
                    queue.Remove(playerInfo.SoldierName);
                }
            }
        }
        #endregion

        #region listplayers
        public virtual void OnListPlayers(List<CPlayerInfo> lstPlayers, CPlayerSubset cpsSubset)
        {
            try
            {
                DateTime viphelper = viplastcheck.AddSeconds(59.0);
                if (DateTime.Compare(viphelper, DateTime.Now) <= 0)
                {
                    this.ExecuteCommand("procon.protected.send", "reservedSlotsList.list");
                    
                    viplastcheck = DateTime.Now;
                }
                DateTime timehelper = lastcheck.AddSeconds(batchtimeout);
                if (DateTime.Compare(timehelper, DateTime.Now) <= 0 && DoStatsCheck == enumBoolYesNo.Yes)
                {
                    log("CD - batch check trigger", 4);

                    checkbatch();

                    lastcheck = DateTime.Now;

                    if (batchtimeoutnormal < batchtimeoutbase)
                    {
                        batchtimeoutnormal = batchtimeoutbase;
                    }

                    if (batchtimeout > batchtimeoutnormal)
                    {
                        batchtimeout = batchtimeoutnormal;
                        log("CD - queue timeout: " + batchtimeout.ToString() + " seconds", 3);
                    }
                }

                DateTime timehelper2 = lastdbsend.AddSeconds(1800);
                if (DateTime.Compare(timehelper2, DateTime.Now) <= 0/* && (DateTime.UtcNow.AddHours(1).TimeOfDay < new TimeSpan(1, 0, 0) || DateTime.UtcNow.AddHours(1).TimeOfDay > new TimeSpan(6, 0, 0))*/)
                {
                    log("CD - batch db send trigger", 4);

                    SendNewPlayersToDB();
                    SendNewPlayersToDBPublic();
                    lastdbsend = DateTime.Now;
                }

                foreach (CPlayerInfo cpiPlayer in lstPlayers)
                {
                    if (m_dicPlayerInfo.ContainsKey(cpiPlayer.SoldierName))
                    {
                        log("CD - maintaining playerdict: " + cpiPlayer.SoldierName, 5);
                        m_dicPlayerInfo[cpiPlayer.SoldierName] = cpiPlayer;
                    }
                    else
                    {
                        log("CD - adding to playerdict: " + cpiPlayer.SoldierName, 4);
                        m_dicPlayerInfo.Add(cpiPlayer.SoldierName, cpiPlayer);
                    }
                }

                //housekeeping the lists: players that exist but not in our list (equal and better than onplayerjoin, because it protects against spamming the join button)
                foreach (CPlayerInfo cpiPlayer in lstPlayers)
                {
                    bool boolplayerexists = false;
                    foreach (String player in myplayerlist)
                    {
                        if (cpiPlayer.SoldierName == player)
                            boolplayerexists = true;
                    }
                    if (!boolplayerexists)
                    {
                        if (whitelist.Contains(cpiPlayer.SoldierName))
                        {
                            log("CD - skipping whitelisted player: " + cpiPlayer.SoldierName, 2);
                            myplayerlist.Add(cpiPlayer.SoldierName);
                        }
                        else
                        {
                            log("CD - adding to playerlist and queue (PlayerJoined): " + cpiPlayer.SoldierName, 4);
                            if (!queue.Contains(cpiPlayer.SoldierName) && !whitelist.Contains(cpiPlayer.SoldierName) && DoStatsCheck == enumBoolYesNo.Yes)
                            {
                                queue.Add(cpiPlayer.SoldierName);
                            }

                            myplayerlist.Add(cpiPlayer.SoldierName);                                                        
                        }

                        if (streamtomaster == enumBoolYesNo.Yes || publicintegration == enumBoolYesNo.Yes)
                        {
                            string pbguid = "";
                            if (m_dicPBPlayerInfo.ContainsKey(cpiPlayer.SoldierName))
                            {
                                pbguid = m_dicPBPlayerInfo[cpiPlayer.SoldierName].GUID;
                            }

                            if (!queuefordb.Contains(new PlayerCheckInfo(cpiPlayer.SoldierName, cpiPlayer.GUID, pbguid, 1))/* && !whitelist.Contains(cpiPlayer.SoldierName)*/)
                            {
                                queuefordb.Add(new PlayerCheckInfo(cpiPlayer.SoldierName, cpiPlayer.GUID, pbguid, 1));
                            }
                        }
                    }
                }
                if (test == enumBoolYesNo.Yes)
                {
                    foreach (string player in tempplayertocheck)
                    {
                        if (!queue.Contains(player))
                        {
                            log("CD - adding to queue: " + player, 1);
                            queue.Insert(0, player);
                        }

                        log("CD - adding to queuefordb: " + player, 1);

                        string eaguid = "";
                        string pbguid = "";
                        if (m_dicPlayerInfo.ContainsKey(player))
                        {
                            eaguid = m_dicPlayerInfo[player].GUID;
                        }
                        if (m_dicPBPlayerInfo.ContainsKey(player))
                        {
                            pbguid = m_dicPBPlayerInfo[player].GUID;
                        }
                        queuefordb.Insert(0, new PlayerCheckInfo(player, eaguid, pbguid, 0));
                    }
                    test = enumBoolYesNo.No;
                }

                if (SyncResetPlayerLists)
                {
                    SyncResetPlayerLists = false;

                    log("CD - resetting/syncing playerdicts", 4);

                    kills = new Dictionary<string, double>();
                    hs = new Dictionary<string, double>();
                    firstkill = new Dictionary<string, DateTime>();

                    m_dicPlayerInfo = new Dictionary<string, CPlayerInfo>();
                    m_dicPBPlayerInfo = new Dictionary<string, CPunkbusterInfo>();
                    CacheDict = new Dictionary<string, Dictionary<string, string>>();
                    playerErrors = new Dictionary<string, int>();
                    myplayerlist = new List<string>();

                    foreach (CPlayerInfo player in lstPlayers)
                    {
                        m_dicPlayerInfo.Add(player.SoldierName, player);
                        myplayerlist.Add(player.SoldierName);
                    }
                }

                if (DoLiveCheck == enumBoolYesNo.Yes)
                {
                    DateTime timehelper3 = lastcheck2.AddSeconds(300);
                    if (DateTime.Compare(timehelper3, DateTime.Now) <= 0 && DoLiveCheck == enumBoolYesNo.Yes)
                    {
                        lastcheck2 = DateTime.Now;
                        livecheck(lstPlayers);
                    }
                }
            }
            catch (Exception ex)
            {
                log("CD - ERROR CD.OnListPlayers: " + ex, 1);
            }
        }

        private void SendNewPlayersToDB()
        {
            if (streamtomaster == enumBoolYesNo.Yes && DoConnect == enumBoolYesNo.Yes && DB != null)
            {
                DB.Insert(queuefordb.ToArray());
                queuefordb = new List<PlayerCheckInfo>();
            }
        }
        #endregion

        private void SendNewPlayersToDBPublic()
        {
            if (publicintegration == enumBoolYesNo.Yes && queuefordb.Count > 0)
            {
                try
                {
                    string query = "";

                    int i = 0;
                    foreach (PlayerCheckInfo pci in queuefordb)
                    {
                        query += pci.name;
                        i++;

                        if (i != queuefordb.Count)
                        {
                            query += ";";
                        }
                    }

                    log("http://www.247fairplay.com/cheatdetector.php?add=" + Uri.EscapeUriString(query), 3);

                    webclient.DownloadStringAsync(new Uri("http://www.247fairplay.com/cheatdetector.php?add=" + Uri.EscapeUriString(query)));

                    queuefordb = new List<PlayerCheckInfo>();
                }
                catch (Exception ex)
                {
                    log("CD - ERROR CD.SendNewPlayersToDBPublic(): " + ex, 1);                    
                }
            }
        }

        #region getresult
        public void getResult(object sender, DoWorkEventArgs e)
        {
            string playername = e.Argument.ToString();
            try
            {
                /* First fetch the player's main page to get the persona id */
                string[] result = new string[3];
                result[1] = playername;
                BattlelogClient bclient = new BattlelogClient(this);
                bclient.fetchWebPage(ref result[0], "http://battlelog.battlefield.com/bf3/user/" + playername);

                /* Extract the persona id */
                MatchCollection pid = Regex.Matches(result[0], @"bf3/soldier/" + playername + @"/stats/(\d+)(/\w*)?/", RegexOptions.IgnoreCase | RegexOptions.Singleline);

                String personaId = "";

                foreach (Match m in pid)
                {
                    if (m.Success && m.Groups[2].Value.Trim() != "/ps3" && m.Groups[2].Value.Trim() != "/xbox")
                    {
                        personaId = m.Groups[1].Value.Trim();
                    }
                }

                if (personaId == "")
                {
                    throw new Exception("could not find persona-id for " + playername);
                }

                bclient.fetchWebPage(ref result[0], "http://battlelog.battlefield.com/bf3/weaponsPopulateStats/" + personaId + "/1/");
                bclient.fetchWebPage(ref result[2], "http://battlelog.battlefield.com/bf3/overviewPopulateStats/" + personaId + "/bf3-us-engineer/1/");
                e.Result = result;
            }
            catch (WebException ex)
            {
                log("CD - WebException getResult: " + ex.Message, 3);
                log("CD - Battlelog Request Limit reached.", 2);
                //batchtimeout += batchtimeoutsleep;
                if (batchtimeoutnormal < batchtimeoutmax)
                {
                    log("CD - Increasing queue timeout by " + batchtimeoutmodinc.ToString() + " seconds.", 2);
                    batchtimeoutnormal += batchtimeoutmodinc;
                }
                batchtimeout = batchtimeoutnormal;

                backAdd(playername);
            }
            catch (Exception ex)
            {
                log("CD - Exception getResult: " + ex.Message, 3);
            }
        }
        #endregion

        #region analyzeresult
        public void analyzeResult(object sender, RunWorkerCompletedEventArgs e)
        {
            try
            {
                string[] args = e.Result as string[];
                string playername = args[1];
                string result = args[0];
                string resultforspm = args[2];
                universalAnalyzer(playername, resultforspm, result);
            }
            catch (StatsException ex)
            {
                log("CD - StatsException analyzeResult: " + ex.Message, 4);
            }
            catch (Exception ex)
            {
                log("CD - Exception analyzeResult: " + ex.Message, 4);
            }
        }
        #endregion

        #region checkplayer
        public void checkPlayer(String playername)
        {
            BackgroundWorker worker = new BackgroundWorker();
            worker.DoWork += getResult;
            worker.RunWorkerCompleted += analyzeResult;
            worker.RunWorkerAsync(playername);
        }
        #endregion

        #region checkplayercached
        private void checkPlayerCached(string player)
        {
            try
            {
                log("CD - function checkPlayerCached entered", 5);
                lock (CacheDict)
                {
                    log("CD - lock entered", 5);
                    if (!CacheDict.ContainsKey(player))
                    {
                        CacheDict.Add(player, new Dictionary<string, string>());
                        CacheDict[player].Add("overview", null);
                        CacheDict[player].Add("weapon", null);
                        //CacheDict[player] = null;
                        //CacheDict[player]["overview"] = null;
                        //CacheDict[player]["weapon"] = null;
                    }
                }

                log("CD - sending Cache Requests for: " + player, 4);

                SendCacheRequest(player, "overview");
                SendCacheRequest(player, "weapon");
            }
            catch (Exception ex)
            {
                log("CD - Exception in checkPlayerCached: " + ex.Message, 3);
            }
        }
        #endregion

        #region CacheAnalyzeResult
        public void CacheAnalyzeResult(params String[] response)
        {
            string playername = response[0];
            try
            {
                string val = "";
                log("CD - CacheAnalyzeResult called with " + response.Length + " parameters", 5);
                if (debuglevel >= 5)
                { // This is just for debugging, dumps all the result parameters
                    for (int i = 0; i < response.Length; ++i)
                    {
                        log("#" + i + ") Length: " + response[i].Length, 5);
                        val = response[i];
                        if (val.Length > 100) val = val.Substring(0, 100) + " ... ";
                        {
                            if (val.Contains("{")) val = val.Replace('{', '<').Replace('}', '>'); // ConsoleWrite doesn't like messages with "{" in it
                            {
                                log("#" + i + ") Value: " + val, 5);
                            }
                        }
                    }
                }

                //String magicplayerName = response[0]; // Player's name
                //string[] temp = response[0].Split(magic.ToCharArray());
                //string playername = response[0];
                //string responsetype = response[1];
                string jsonstring = response[1]; // JSON string

                // ... now you can call analyzeResult or something similar to it

                lock (CacheDict)
                {
                    if (CacheDict[playername] != null)
                    {
                        Hashtable json = (Hashtable)JSON.JsonDecode(jsonstring);
                        Hashtable statsforspm = null;

                        // check we got a valid response
                        if (!(json.ContainsKey("type") && json.ContainsKey("message")))
                        {
                            throw new Exception("JSON response does not contain \"type\" or \"message\" fields");
                        }

                        String type = (String)json["type"];
                        String message = (String)json["message"];

                        /* verify we got a success message */
                        if (!(type.StartsWith("success") && message.StartsWith("OK")))
                        {
                            throw new Exception("JSON response was type=" + type + ", message=" + message);
                        }

                        /* verify there is data structure */
                        Hashtable data = null;
                        if (!json.ContainsKey("data") || (data = (Hashtable)json["data"]) == null)
                        {
                            throw new Exception("JSON response was does not contain a data field");
                        }
                        //plugin.ExecuteCommand("procon.protected.pluginconsole.write", "1");
                        ArrayList weaponsstats = null;
                        if (!data.ContainsKey("mainWeaponStats") || (weaponsstats = (ArrayList)data["mainWeaponStats"]) == null)
                        {
                            CacheDict[playername]["overview"] = jsonstring;
                        }
                        else if (!data.ContainsKey("overviewStats") || (statsforspm = (Hashtable)data["overviewStats"]) == null)
                        {
                            CacheDict[playername]["weapon"] = jsonstring;
                        }
                        else
                        {
                            throw new StatsException("ERROR: JSON response data does not contain mainWeaponStats or overviewStats");
                        }
                    }
                }
                if (CacheDict[playername]["overview"] != null && CacheDict[playername]["weapon"] != null)
                {
                    universalAnalyzer(playername, CacheDict[playername]["overview"], CacheDict[playername]["weapon"]);
                    CacheDict.Remove(playername);
                }
            }
            catch (Exception ex)
            {
                log("CD - Exception in CacheAnalyzeResult: " + ex.Message, 3);
                backAdd(playername);
            }
        }
        #endregion

        #region universalAnalyzer
        private void universalAnalyzer(string playername, string overviewStats, string weaponStats)
        {
            try
            {
                double cheatindex = 0.0;
                string bestreason = "";
                Dictionary<double, string> reasons = new Dictionary<double, string>();

                Hashtable json = (Hashtable)JSON.JsonDecode(weaponStats);

                // check we got a valid response
                if (!(json.ContainsKey("type") && json.ContainsKey("message")))
                {
                    throw new Exception("JSON response does not contain \"type\" or \"message\" fields");
                }

                String type = (String)json["type"];
                String message = (String)json["message"];

                /* verify we got a success message */
                if (!(type.StartsWith("success") && message.StartsWith("OK")))
                {
                    throw new Exception("JSON response was type=" + type + ", message=" + message);
                }

                /* verify there is data structure */
                Hashtable data = null;
                if (!json.ContainsKey("data") || (data = (Hashtable)json["data"]) == null)
                {
                    throw new Exception("JSON response was does not contain a data field");
                }
                //plugin.ExecuteCommand("procon.protected.pluginconsole.write", "1");

                ArrayList weaponsstats = null;
                if (!data.ContainsKey("mainWeaponStats") || (weaponsstats = (ArrayList)data["mainWeaponStats"]) == null)
                {
                    throw new StatsException("ERROR: JSON response data does not contain mainWeaponStats");
                }

                for (int i = 0; i < weaponsstats.Count; i++)
                {
                    Hashtable weapon = null;
                    if ((weapon = (Hashtable)weaponsstats[i]) == null)
                    {
                        throw new StatsException("ERROR: JSON response mainWeaponStats does not contain " + i);
                    }

                    // get the data fields
                    string weaponname = weapon["name"].ToString();
                    double kills = Convert.ToDouble(weapon["kills"].ToString());
                    double shots = Convert.ToDouble(weapon["shotsFired"].ToString());
                    double hits = Convert.ToDouble(weapon["shotsHit"].ToString());
                    double headshots = Convert.ToDouble(weapon["headshots"].ToString());
                    double acc = Convert.ToDouble(weapon["accuracy"].ToString());
                    double time = Convert.ToDouble(weapon["timeEquipped"].ToString());

                    //if (kills >= minkills)
                    //{
                        log("CD - checking weapon: " + weaponname, 5);
                        cheatindex += checkAccuracy(ref reasons, playername, weaponname, acc, kills);
                        cheatindex += checkHeadshotsperKill(ref reasons, playername, weaponname, headshots, kills);
                        cheatindex += checkKillsperHit(ref reasons, playername, weaponname, kills, hits);
                        cheatindex += checkKillsperMin(ref reasons, playername, weaponname, kills, time);
                    //}
                    //else
                    //{
                    //    log("CD - skipping weapon (less than " + minkills.ToString() + " kills): " + weaponname, 5);
                    //}
                }

                Hashtable jsonforspm = (Hashtable)JSON.JsonDecode(overviewStats);

                // check we got a valid response
                if (!(jsonforspm.ContainsKey("type") && jsonforspm.ContainsKey("message")))
                {
                    throw new Exception("JSON response does not contain \"type\" or \"message\" fields");
                }

                String typeforspm = (String)jsonforspm["type"];
                String messageforspm = (String)jsonforspm["message"];

                /* verify we got a success message */
                if (!(typeforspm.StartsWith("success") && messageforspm.StartsWith("OK")))
                {
                    throw new Exception("JSON response was type=" + typeforspm + ", message=" + messageforspm);
                }


                /* verify there is data structure */
                Hashtable dataforspm = null;
                if (!jsonforspm.ContainsKey("data") || (dataforspm = (Hashtable)jsonforspm["data"]) == null)
                {
                    throw new Exception("JSON response was does not contain a data field");
                }

                Hashtable statsforspm = null;
                if (!dataforspm.ContainsKey("overviewStats") || (statsforspm = (Hashtable)dataforspm["overviewStats"]) == null)
                {
                    throw new StatsException("ERROR: JSON response data does not contain overviewStats");
                }

                double score = 0;
                double timePlayed = 0;
                double spm = 0;

                score = Convert.ToDouble(statsforspm["score"].ToString());
                timePlayed = Convert.ToDouble(statsforspm["timePlayed"].ToString());

                if (score != 0 && timePlayed >= 3600)
                {
                    spm = Math.Round(score / (timePlayed / 60), 2);
                }
                else
                {
                    spm = 0;
                }

                log("CD - spm: " + spm.ToString(), 4);

                if (spm > redspm)
                {
                    log("CD - IMPOSSIBLE STATS: " + playername + " spm: " + spm.ToString(), 1);
                    cheatindex += (redflagcount - 0.5);
                }
                else if (spm > orangespm)
                {
                    log("CD - Suspicious stats: " + playername + " spm: " + spm.ToString(), 1);
                    cheatindex += (orangeflagcount - 0.5);
                }

                double cheatpercent = cheatindex / GetCILimit();
                if (cheatpercent > 0.99)
                {
                    cheatpercent = 0.99;
                }
                cheatpercent = cheatpercent * 100;

                if (cheatindex < GetCILimit()) //debuginfo
                {
                    if (cheatindex > 0.0)
                    {
                        log("CD - " + playername + ": " + cheatpercent.ToString() + "%", 1);
                    }
                    else
                    {
                        log("CD - " + playername + ": " + cheatpercent.ToString() + "%", 2);
                    }
                }

                if (cheatindex >= GetCILimit())
                {
                    double bestscore = 0;
                    foreach (KeyValuePair<double, string> kvp in reasons)
                    {
                        if (kvp.Key > bestscore)
                        {
                            bestscore = kvp.Key;
                            bestreason = kvp.Value;
                        }
                    }

                    if (myplayerlist.Contains(playername) && (enableban == enumBoolYesNo.Yes || enabletban == enumBoolYesNo.Yes || enablekick == enumBoolYesNo.Yes))
                    {
                        myplayerlist.Remove(playername);
                    }

                    punish(playername, bestreason);

                    if (enableingamenotify == enumBoolYesNo.Yes) //is ingamenotify enabled?
                    {
                        if (enableingamepubnotifysay == enumBoolYesNo.Yes)
                        {
                            string msg = formatMsg(publicnotifysaytext, playername, bestreason, m_dicPBPlayerInfo[playername].GUID, m_dicPlayerInfo[playername].GUID);                            
                            ExecuteCommand("procon.protected.tasks.add", "CheatDetector", "0", "1", "1", "procon.protected.send", "admin.say", msg, "all"); //untested, kinda double op here
                        }
                        if (enableingamepubnotifyyell == enumBoolYesNo.Yes)
                        {
                            string msg = formatMsg(publicnotifyyelltext, playername, bestreason, m_dicPBPlayerInfo[playername].GUID, m_dicPlayerInfo[playername].GUID);
                            ExecuteCommand("procon.protected.tasks.add", "CheatDetector", "0", "1", "1", "procon.protected.send", "admin.yell", msg, ingamepublicnotifytime.ToString(), "all"); //untested, kinda double op here
                        }
                        if (enableingameprivpyell == enumBoolYesNo.Yes)
                        {
                            foreach (string name in ingameaccountnamepyell)
                            {
                                string msg = formatMsg(privatenotifypsaytext, playername, bestreason, m_dicPBPlayerInfo[playername].GUID, m_dicPlayerInfo[playername].GUID);
                                ExecuteCommand("procon.protected.tasks.add", "CheatDetector", "0", "1", "1", "procon.protected.send", "admin.yell", name + ": " + msg, ingameprivnotifytime.ToString(), "player", name); //works, kinda double op here
                            }
                        }
                        if (enableingameprivpsay == enumBoolYesNo.Yes)
                        {
                            foreach (string name in ingameaccountnamepyell)
                            {
                                string msg = formatMsg(privatenotifypyelltext, playername, bestreason, m_dicPBPlayerInfo[playername].GUID, m_dicPlayerInfo[playername].GUID);
                                ExecuteCommand("procon.protected.tasks.add", "CheatDetector", "0", "1", "1", "procon.protected.send", "admin.say", name + ": " + msg, "player", name); //untested, kinda double op here
                            }
                        }
                    }

                    log("CD - SUSPECTED CHEATING: " + playername + " " + cheatpercent.ToString() + "%", 1);
                    log("------------------------", 1);
                    //log("CD - Reason: " + bestreason, 1);
                }

                if (batchtimeoutnormal > batchtimeoutbase)
                {
                    log("CD - decreasing next queue timeout by: " + batchtimeoutmoddec.ToString() + " seconds", 4);
                    batchtimeoutnormal -= batchtimeoutmoddec;
                }
            }
            catch (Exception ex)
            {
                log("CD - Exception universalAnalyzer: " + ex.Message, 3);
            }
        }

        private double GetCILimit()
        {
            if (strictmode == enumBoolYesNo.Yes)
            {
                return 5.0;
            }
            else
            {
                return 6.5;
            }
        }

        #endregion

        private void punish(string name, string bestreason)
        {
            if (enableban == enumBoolYesNo.Yes) //is ban enabled?
            {
                string msg = formatMsg(bantext, name, bestreason, m_dicPBPlayerInfo[name].GUID, m_dicPlayerInfo[name].GUID);
                if (banbyname == enumBoolYesNo.Yes || banbyeaguid == enumBoolYesNo.Yes)
                {
                    if (banbyeaguid == enumBoolYesNo.Yes)
                    {
                        ExecuteCommand("procon.protected.send", "banList.add", "guid", m_dicPlayerInfo[name].GUID, "perm", msg);
                    }
                    if (banbyname == enumBoolYesNo.Yes)
                    {
                        ExecuteCommand("procon.protected.send", "banList.add", "name", name, "perm", msg);
                    }
                    ExecuteCommand("procon.protected.send", "banList.save");
                    ExecuteCommand("procon.protected.send", "banList.list");
                }
                if (banbypbguid == enumBoolYesNo.Yes)
                {
                    ExecuteCommand("procon.protected.send", "punkBuster.pb_sv_command", String.Format("pb_sv_ban \"{0}\" \"{1}\"", name, "BC2! " + msg));
                }
            }
            else if (enabletban == enumBoolYesNo.Yes) //is tban enabled?
            {
                string msg = formatMsg(tbantext, name, bestreason, m_dicPBPlayerInfo[name].GUID, m_dicPlayerInfo[name].GUID);
                if (banbyname == enumBoolYesNo.Yes || banbyeaguid == enumBoolYesNo.Yes)
                {
                    if (banbyeaguid == enumBoolYesNo.Yes)
                    {
                        ExecuteCommand("procon.protected.send", "banList.add", "guid", m_dicPlayerInfo[name].GUID, "seconds", (tbantime * 60).ToString(), msg);
                    }
                    if (banbyname == enumBoolYesNo.Yes)
                    {
                        ExecuteCommand("procon.protected.send", "banList.add", "name", name, "seconds", (tbantime * 60).ToString(), msg);
                    }
                    ExecuteCommand("procon.protected.send", "banList.save");
                    ExecuteCommand("procon.protected.send", "banList.list");
                }
                if (banbypbguid == enumBoolYesNo.Yes)
                {
                    ExecuteCommand("procon.protected.send", "punkBuster.pb_sv_command", String.Format("pb_sv_kick \"{0}\" {1} \"{2}\"", name, tbantime.ToString(), "BC2! " + msg));
                }
            }
            else if (enablekick == enumBoolYesNo.Yes) //is kick enabled?
            {
                string msg = formatMsg(kicktext, name, bestreason, m_dicPBPlayerInfo[name].GUID, m_dicPlayerInfo[name].GUID);
                ExecuteCommand("procon.protected.send", "admin.kickPlayer", name, msg);
            }

            if (enableban == enumBoolYesNo.Yes || enabletban == enumBoolYesNo.Yes || enablekick == enumBoolYesNo.Yes)
            {
                ExecuteCommand("procon.protected.send", "admin.kickPlayer", name, ""); //just to be sure hes gone
            }
        }

        #region SendCacheRequest
        public void SendCacheRequest(String playerName, String requestType)
        {
            /* 
            This is like setting up a BackgroundWorker and launching it asynchronously.
            */
            Hashtable request = new Hashtable();
            request["playerName"] = playerName;
            request["pluginName"] = "CheatDetector"; // your plugin name here
            request["pluginMethod"] = "CacheAnalyzeResult"; // your callback method name here
            request["requestType"] = requestType;

            ExecuteCommand("procon.protected.plugins.call", "CBattlelogCache", "PlayerLookup", JSON.JsonEncode(request));
        }
        #endregion

        #region checkKillsperMin
        public double checkKillsperMin(ref Dictionary<double, string> reasons, string playername, string weaponname, double kills, double time)
        {
            time = time / 60.0;

            if (weaponname == "Underslung Shotgun" || weaponname == "XP1 Jackhammer" || weaponname == "M1014" || weaponname == "DAO" || weaponname == "XP2 SPAS12" || weaponname == "870" || weaponname == "USAS" || weaponname == "Saiga" || weaponname == "RPG-7" || weaponname == "Mk153 SMAW" || weaponname == "FGM-148 JAVELIN" || weaponname == "Underslung Launcher" || weaponname == "SA-18 IGLA AA" || weaponname == "FIM-92 STINGER AA" || weaponname == "Knife") //unreliable
                return 0.0;

            if (weaponname == "Crossbow Scoped" || weaponname == "Crossbow kobra") //no avg yet
                return 0.0;

            //double avgkm;
            double avgkmyellow;
            double avgkmred;

            switch (weaponname)
            {
                case "MK11":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "SVD":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "SKS":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M39":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "Pecheneg":
                    avgkmyellow = 6; avgkmred = 9.6; //avgkm = 1.2;
                    break;
                case "G36C":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M412 Rex":
                    avgkmyellow = 6.4; avgkmred = 10.24; //avgkm = 1.28;
                    break;
                case "SV98":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "RPG-7":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "Saiga":
                    avgkmyellow = 7.7; avgkmred = 12.32; //avgkm = 1.54;
                    break;
                case "Glock 17":
                    avgkmyellow = 5.9; avgkmred = 9.44; //avgkm = 1.18;
                    break;
                case "AN94":
                    avgkmyellow = 6.15; avgkmred = 9.84; //avgkm = 1.23;
                    break;
                case "M60":
                    avgkmyellow = 5.45; avgkmred = 8.72; //avgkm = 1.09;
                    break;
                case "M27":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M1911 LIT":
                    avgkmyellow = 6.1; avgkmred = 9.76; //avgkm = 1.22;
                    break;
                case "SCAR":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "Glock 18 Silenced":
                    avgkmyellow = 5.9; avgkmred = 9.44; //avgkm = 1.18;
                    break;
                case "UMP":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "PDR":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M98B":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M9 Silenced":
                    avgkmyellow = 5.75; avgkmred = 9.2; //avgkm = 1.15;
                    break;
                case "XP2 L86A1":
                    avgkmyellow = 6.3; avgkmred = 10.08; //avgkm = 1.26;
                    break;
                case "M40A5":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "USAS":
                    avgkmyellow = 6.75; avgkmred = 10.8; //avgkm = 1.35;
                    break;
                case "XP2 LSAT":
                    avgkmyellow = 6.85; avgkmred = 10.96; //avgkm = 1.37;
                    break;
                case "XP1 QBB95":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP1 HK53":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M1911":
                    avgkmyellow = 5.95; avgkmred = 9.52; //avgkm = 1.19;
                    break;
                case "XP1 QBU88":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M16A4":
                    avgkmyellow = 7.1; avgkmred = 11.36; //avgkm = 1.42;
                    break;
                case "XP2 AUG":
                    avgkmyellow = 7.8; avgkmred = 12.48; //avgkm = 1.56;
                    break;
                case "M1014":
                    avgkmyellow = 7.4; avgkmred = 11.84; //avgkm = 1.48;
                    break;
                case "AEK971":
                    avgkmyellow = 6.45; avgkmred = 10.32; //avgkm = 1.29;
                    break;
                case "G3A3":
                case "G3A4":
                    avgkmyellow = 6; avgkmred = 9.6; //avgkm = 1.2;
                    break;
                case "Taurus 44":
                    avgkmyellow = 6.3; avgkmred = 10.08; //avgkm = 1.26;
                    break;
                case "AKS74U":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "Glock 17 Silenced":
                    avgkmyellow = 5.5; avgkmred = 8.8; //avgkm = 1.1;
                    break;
                case "M1911 Tactical":
                    avgkmyellow = 6.1; avgkmred = 9.76; //avgkm = 1.22;
                    break;
                case "Underslung Launcher":
                    avgkmyellow = 7.1; avgkmred = 11.36; //avgkm = 1.42;
                    break;
                case "M416":
                    avgkmyellow = 5.65; avgkmred = 9.04; //avgkm = 1.13;
                    break;
                case "Glock 18":
                    avgkmyellow = 5.7; avgkmred = 9.12; //avgkm = 1.14;
                    break;
                case "FGM-148 JAVELIN":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "F2000":
                    avgkmyellow = 6.1; avgkmred = 9.76; //avgkm = 1.22;
                    break;
                case "M1911 SILENCED":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "MP443 LIT":
                    avgkmyellow = 6.25; avgkmred = 10; //avgkm = 1.25;
                    break;
                case "Taurus 44 scoped":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP1 L96":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "RPK":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP1 FAMAS":
                    avgkmyellow = 5.35; avgkmred = 8.56; //avgkm = 1.07;
                    break;
                case "AK74M":
                    avgkmyellow = 5.15; avgkmred = 8.24; //avgkm = 1.03;
                    break;
                case "M249":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "A91":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "AS-VAL":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "P90":
                    avgkmyellow = 5.9; avgkmred = 9.44; //avgkm = 1.18;
                    break;
                case "M93R":
                    avgkmyellow = 7.5; avgkmred = 12; //avgkm = 1.5;
                    break;
                case "XP1 PP19":
                    avgkmyellow = 5.15; avgkmred = 8.24; //avgkm = 1.03;
                    break;
                case "870":
                    avgkmyellow = 6.55; avgkmred = 10.48; //avgkm = 1.31;
                    break;
                case "XP2 HK417":
                    avgkmyellow = 6.75; avgkmred = 10.8; //avgkm = 1.35;
                    break;
                case "MP443 Silenced":
                    avgkmyellow = 6.1; avgkmred = 9.76; //avgkm = 1.22;
                    break;
                case "M9 Flashlight":
                    avgkmyellow = 5.95; avgkmred = 9.52; //avgkm = 1.19;
                    break;
                case "PP2000":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP2 SPAS12":
                    avgkmyellow = 9.65; avgkmred = 15.44; //avgkm = 1.93;
                    break;
                case "MP7":
                    avgkmyellow = 6.15; avgkmred = 9.84; //avgkm = 1.23;
                    break;
                case "Underslung Shotgun":
                    avgkmyellow = 7.1; avgkmred = 11.36; //avgkm = 1.42;
                    break;
                case "MP 443":
                    avgkmyellow = 5.75; avgkmred = 9.2; //avgkm = 1.15;
                    break;
                case "XP1 L85A2":
                    avgkmyellow = 6.15; avgkmred = 9.84; //avgkm = 1.23;
                    break;
                case "DAO":
                    avgkmyellow = 7.25; avgkmred = 11.6; //avgkm = 1.45;
                    break;
                case "SG553":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "Type88":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "SA-18 IGLA AA":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "Knife":
                    avgkmyellow = 17.35; avgkmred = 27.76; //avgkm = 3.47;
                    break;
                case "M240":
                    avgkmyellow = 5.4; avgkmred = 8.64; //avgkm = 1.08;
                    break;
                case "XP2 MTAR-21":
                    avgkmyellow = 7.15; avgkmred = 11.44; //avgkm = 1.43;
                    break;
                case "KH2002":
                    avgkmyellow = 6.4; avgkmred = 10.24; //avgkm = 1.28;
                    break;
                case "XP1 Jackhammer":
                    avgkmyellow = 7.45; avgkmred = 11.92; //avgkm = 1.49;
                    break;
                case "XP2 SCARL":
                    avgkmyellow = 8.1; avgkmred = 12.96; //avgkm = 1.62;
                    break;
                case "XP2 MP5K":
                    avgkmyellow = 7.95; avgkmred = 12.72; //avgkm = 1.59;
                    break;
                case "FIM-92 STINGER AA":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "M9":
                    avgkmyellow = 5.55; avgkmred = 8.88; //avgkm = 1.11;
                    break;
                case "XP2 ACR":
                    avgkmyellow = 5.7; avgkmred = 9.12; //avgkm = 1.14;
                    break;
                case "M4A1":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP2 JNG90":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP1 QBZ95B":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;
                case "XP1 MG36":
                    avgkmyellow = 5.3; avgkmred = 8.48; //avgkm = 1.06;
                    break;
                case "Mk153 SMAW":
                    avgkmyellow = 5; avgkmred = 8; //avgkm = 1;
                    break;


                default:
                    log("CD - weapon avg kills/min not found: " + weaponname, 1);
                    //avgkm = 1.0;
                    avgkmyellow = 100.0; avgkmred = 100.0;
                    break;
            }

            double kpm = Math.Round(kills / time, 2);
            double kpmabove = Math.Round((kills / time) / (avgkmyellow/5), 2);

            double cheatindex = 0.0;
            if (kills > minkills)
            {
                if ((kills / time) > avgkmred)
                {
                    log("CD - IMPOSSIBLE STATS: " + playername + " " + weaponname + " k/m: " + kpm.ToString() + " (" + kpmabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(kpmabove))
                        reasons.Add(kpmabove, weaponname + " k/m: " + kpm.ToString());

                    cheatindex += redflagcount;
                }
                else if ((kills / time) > avgkmyellow)
                {
                    log("CD - suspicious stats: " + playername + " " + weaponname + " k/m: " + kpm.ToString() + " (" + kpmabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(kpmabove / 2.0))
                        reasons.Add(kpmabove / 2.0, weaponname + " k/m: " + kpm.ToString());

                    cheatindex += orangeflagcount;
                }
            }
            else
            {
                log("CD - skipping weapon (less than " + minkills.ToString() + " kills): " + weaponname, 5);
            }
            log("CD - kills/min: " + kpm.ToString(), 5);
            return cheatindex;
        }
        #endregion

        #region checkKillsperHit
        public double checkKillsperHit(ref Dictionary<double, string> reasons, string playername, string weaponname, double kills, double hits)
        {
            if (weaponname == "Underslung Shotgun" || weaponname == "XP1 Jackhammer" || weaponname == "M1014" || weaponname == "DAO" || weaponname == "XP2 SPAS12" || weaponname == "870" || weaponname == "USAS" || weaponname == "Saiga" || weaponname == "RPG-7" || weaponname == "Mk153 SMAW" || weaponname == "FGM-148 JAVELIN" || weaponname == "Underslung Launcher" || weaponname == "SA-18 IGLA AA" || weaponname == "FIM-92 STINGER AA" || weaponname == "Knife") //unreliable
                return 0.0;

            if (weaponname == "Crossbow Scoped" || weaponname == "Crossbow kobra") //no avg yet
                return 0.0;

            //double avgkh;
            double avgkhyellow;
            double avgkhred;


            switch (weaponname)
            {
                case "MK11":
                    avgkhyellow = 0.8478; avgkhred = 1; //avgkh = 0.314;
                    break;
                case "SVD":
                    avgkhyellow = 0.86562; avgkhred = 1; //avgkh = 0.3206;
                    break;
                case "SKS":
                    avgkhyellow = 0.68985; avgkhred = 0.8176; //avgkh = 0.2555;
                    break;
                case "M39":
                    avgkhyellow = 0.86049; avgkhred = 1; //avgkh = 0.3187;
                    break;
                case "Pecheneg":
                    avgkhyellow = 0.56511; avgkhred = 0.66976; //avgkh = 0.2093;
                    break;
                case "G36C":
                    avgkhyellow = 0.44226; avgkhred = 0.52416; //avgkh = 0.1638;
                    break;
                case "M412 Rex":
                    avgkhyellow = 0.94851; avgkhred = 1; //avgkh = 0.3513;
                    break;
                case "SV98":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.4803;
                    break;
                case "RPG-7":
                    avgkhyellow = 0.51894; avgkhred = 0.61504; //avgkh = 0.1922;
                    break;
                case "Saiga":
                    avgkhyellow = 0.49194; avgkhred = 0.58304; //avgkh = 0.1822;
                    break;
                case "Glock 17":
                    avgkhyellow = 0.49761; avgkhred = 0.58976; //avgkh = 0.1843;
                    break;
                case "AN94":
                    avgkhyellow = 0.43308; avgkhred = 0.51328; //avgkh = 0.1604;
                    break;
                case "M60":
                    avgkhyellow = 0.53946; avgkhred = 0.63936; //avgkh = 0.1998;
                    break;
                case "M27":
                    avgkhyellow = 0.44064; avgkhred = 0.52224; //avgkh = 0.1632;
                    break;
                case "M1911 LIT":
                    avgkhyellow = 0.67554; avgkhred = 0.80064; //avgkh = 0.2502;
                    break;
                case "SCAR":
                    avgkhyellow = 0.53514; avgkhred = 0.63424; //avgkh = 0.1982;
                    break;
                case "Glock 18 Silenced":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "UMP":
                    avgkhyellow = 0.43281; avgkhred = 0.51296; //avgkh = 0.1603;
                    break;
                case "PDR":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "M98B":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.5281;
                    break;
                case "M9 Silenced":
                    avgkhyellow = 0.48303; avgkhred = 0.57248; //avgkh = 0.1789;
                    break;
                case "XP2 L86A1":
                    avgkhyellow = 0.43875; avgkhred = 0.52; //avgkh = 0.1625;
                    break;
                case "M40A5":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.5213;
                    break;
                case "USAS":
                    avgkhyellow = 0.47439; avgkhred = 0.56224; //avgkh = 0.1757;
                    break;
                case "XP2 LSAT":
                    avgkhyellow = 0.43659; avgkhred = 0.51744; //avgkh = 0.1617;
                    break;
                case "XP1 QBB95":
                    avgkhyellow = 0.44037; avgkhred = 0.52192; //avgkh = 0.1631;
                    break;
                case "XP1 HK53":
                    avgkhyellow = 0.44766; avgkhred = 0.53056; //avgkh = 0.1658;
                    break;
                case "M1911":
                    avgkhyellow = 0.65961; avgkhred = 0.78176; //avgkh = 0.2443;
                    break;
                case "XP1 QBU88":
                    avgkhyellow = 0.89181; avgkhred = 1; //avgkh = 0.3303;
                    break;
                case "M16A4":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "XP2 AUG":
                    avgkhyellow = 0.44901; avgkhred = 0.53216; //avgkh = 0.1663;
                    break;
                case "M1014":
                    avgkhyellow = 0.5265; avgkhred = 0.624; //avgkh = 0.195;
                    break;
                case "AEK971":
                    avgkhyellow = 0.44604; avgkhred = 0.52864; //avgkh = 0.1652;
                    break;
                case "G3A3":
                case "G3A4":
                    avgkhyellow = 0.57942; avgkhred = 0.68672; //avgkh = 0.2146;
                    break;
                case "Taurus 44":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.3866;
                    break;
                case "AKS74U":
                    avgkhyellow = 0.44442; avgkhred = 0.52672; //avgkh = 0.1646;
                    break;
                case "Glock 17 Silenced":
                    avgkhyellow = 0.49518; avgkhred = 0.58688; //avgkh = 0.1834;
                    break;
                case "M1911 Tactical":
                    avgkhyellow = 0.60426; avgkhred = 0.71616; //avgkh = 0.2238;
                    break;
                case "Underslung Launcher":
                    avgkhyellow = 0.67527; avgkhred = 0.80032; //avgkh = 0.2501;
                    break;
                case "M416":
                    avgkhyellow = 0.45036; avgkhred = 0.53376; //avgkh = 0.1668;
                    break;
                case "Glock 18":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "FGM-148 JAVELIN":
                    avgkhyellow = 0.64827; avgkhred = 0.76832; //avgkh = 0.2401;
                    break;
                case "F2000":
                    avgkhyellow = 0.459; avgkhred = 0.544; //avgkh = 0.17;
                    break;
                case "M1911 SILENCED":
                    avgkhyellow = 0.66042; avgkhred = 0.78272; //avgkh = 0.2446;
                    break;
                case "MP443 LIT":
                    avgkhyellow = 0.50166; avgkhred = 0.59456; //avgkh = 0.1858;
                    break;
                case "Taurus 44 scoped":
                    avgkhyellow = 0.9423; avgkhred = 1; //avgkh = 0.349;
                    break;
                case "XP1 L96":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.5054;
                    break;
                case "RPK":
                    avgkhyellow = 0.43308; avgkhred = 0.51328; //avgkh = 0.1604;
                    break;
                case "XP1 FAMAS":
                    avgkhyellow = 0.4536; avgkhred = 0.5376; //avgkh = 0.168;
                    break;
                case "AK74M":
                    avgkhyellow = 0.44388; avgkhred = 0.52608; //avgkh = 0.1644;
                    break;
                case "M249":
                    avgkhyellow = 0.43632; avgkhred = 0.51712; //avgkh = 0.1616;
                    break;
                case "A91":
                    avgkhyellow = 0.44172; avgkhred = 0.52352; //avgkh = 0.1636;
                    break;
                case "AS-VAL":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "P90":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "M93R":
                    avgkhyellow = 0.4995; avgkhred = 0.592; //avgkh = 0.185;
                    break;
                case "XP1 PP19":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "870":
                    avgkhyellow = 0.71442; avgkhred = 0.84672; //avgkh = 0.2646;
                    break;
                case "XP2 HK417":
                    avgkhyellow = 0.88452; avgkhred = 1; //avgkh = 0.3276;
                    break;
                case "MP443 Silenced":
                    avgkhyellow = 0.4833; avgkhred = 0.5728; //avgkh = 0.179;
                    break;
                case "M9 Flashlight":
                    avgkhyellow = 0.50031; avgkhred = 0.59296; //avgkh = 0.1853;
                    break;
                case "PP2000":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "XP2 SPAS12":
                    avgkhyellow = 0.76545; avgkhred = 0.9072; //avgkh = 0.2835;
                    break;
                case "MP7":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "Underslung Shotgun":
                    avgkhyellow = 0.76464; avgkhred = 0.90624; //avgkh = 0.2832;
                    break;
                case "MP 443":
                    avgkhyellow = 0.49626; avgkhred = 0.58816; //avgkh = 0.1838;
                    break;
                case "XP1 L85A2":
                    avgkhyellow = 0.44523; avgkhred = 0.52768; //avgkh = 0.1649;
                    break;
                case "DAO":
                    avgkhyellow = 0.50517; avgkhred = 0.59872; //avgkh = 0.1871;
                    break;
                case "SG553":
                    avgkhyellow = 0.44361; avgkhred = 0.52576; //avgkh = 0.1643;
                    break;
                case "Type88":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "SA-18 IGLA AA":
                    avgkhyellow = 0.6372; avgkhred = 0.7552; //avgkh = 0.236;
                    break;
                case "Knife":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.5277;
                    break;
                case "M240":
                    avgkhyellow = 0.54243; avgkhred = 0.64288; //avgkh = 0.2009;
                    break;
                case "XP2 MTAR-21":
                    avgkhyellow = 0.45792; avgkhred = 0.54272; //avgkh = 0.1696;
                    break;
                case "KH2002":
                    avgkhyellow = 0.44847; avgkhred = 0.53152; //avgkh = 0.1661;
                    break;
                case "XP1 Jackhammer":
                    avgkhyellow = 0.45738; avgkhred = 0.54208; //avgkh = 0.1694;
                    break;
                case "XP2 SCARL":
                    avgkhyellow = 0.44631; avgkhred = 0.52896; //avgkh = 0.1653;
                    break;
                case "XP2 MP5K":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "FIM-92 STINGER AA":
                    avgkhyellow = 0.69795; avgkhred = 0.8272; //avgkh = 0.2585;
                    break;
                case "M9":
                    avgkhyellow = 0.49248; avgkhred = 0.58368; //avgkh = 0.1824;
                    break;
                case "XP2 ACR":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "M4A1":
                    avgkhyellow = 0.432; avgkhred = 0.512; //avgkh = 0.16;
                    break;
                case "XP2 JNG90":
                    avgkhyellow = 1; avgkhred = 1; //avgkh = 0.5262;
                    break;
                case "XP1 QBZ95B":
                    avgkhyellow = 0.43794; avgkhred = 0.51904; //avgkh = 0.1622;
                    break;
                case "XP1 MG36":
                    avgkhyellow = 0.44388; avgkhred = 0.52608; //avgkh = 0.1644;
                    break;
                case "Mk153 SMAW":
                    avgkhyellow = 0.52137; avgkhred = 0.61792; //avgkh = 0.1931;
                    break;


                default:
                    log("CD - weapon avg kills/hit not found: " + weaponname, 1);
                    //avgkh = 1.0;
                    avgkhyellow = 100.0; avgkhred = 100.0;
                    break;
            }

            double kph = Math.Round((kills / hits) * 100.0, 2);
            double kphabove = Math.Round((kills / hits) / (avgkhyellow/2.7), 2);
                        
            double cheatindex = 0.0;
            if (kills > minkills)
            {                
                if ((kills / hits) > avgkhred)
                {
                    log("CD - IMPOSSIBLE STATS: " + playername + " " + weaponname + " k/h: " + kph.ToString() + "%" + " (" + kphabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(kphabove))
                        reasons.Add(kphabove, weaponname + " k/h: " + kph.ToString() + "%");

                    cheatindex += redflagcount;
                }
                else if ((kills / hits) > avgkhyellow)
                {
                    log("CD - suspicious stats: " + playername + " " + weaponname + " k/h: " + kph.ToString() + "%" + " (" + kphabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(kphabove))
                        reasons.Add(kphabove, weaponname + " k/h: " + kph.ToString() + "%");

                    cheatindex += orangeflagcount;
                }
            }
            else
            {
                log("CD - skipping weapon (less than " + minkills.ToString() + " kills): " + weaponname, 5);
            }
            log("CD - kills/hit: " + kph.ToString() + "%", 5);
            return cheatindex;
        }
        #endregion

        #region checkHeadshotsperKill
        public double checkHeadshotsperKill(ref Dictionary<double, string> reasons, string playername, string weaponname, double headshots, double kills)
        {
            if (weaponname == "Underslung Shotgun" || weaponname == "XP1 Jackhammer" || weaponname == "M1014" || weaponname == "DAO" || weaponname == "XP2 SPAS12" || weaponname == "870" || weaponname == "USAS" || weaponname == "Saiga" || weaponname == "RPG-7" || weaponname == "Mk153 SMAW" || weaponname == "FGM-148 JAVELIN" || weaponname == "Underslung Launcher" || weaponname == "SA-18 IGLA AA" || weaponname == "FIM-92 STINGER AA" || weaponname == "Knife") //unreliable
                return 0.0;

            if (weaponname == "Crossbow Scoped" || weaponname == "Crossbow kobra") //no avg yet
                return 0.0;

            //double avghk;
            double avghkyellow;
            double avghkred;

            switch (weaponname)
            {
                case "MK11":
                    //avghk = 0.3844; 
                    avghkyellow = 1.0378; avghkred = 1.23;
                    break;
                case "SVD":
                    //avghk = 0.3802; 
                    avghkyellow = 1.0265; avghkred = 1.2166;
                    break;
                case "SKS":
                    //avghk = 0.309; 
                    avghkyellow = 0.8343; avghkred = 0.9888;
                    break;
                case "M39":
                    //avghk = 0.3813;
                    avghkyellow = 1.0295; avghkred = 1.2201;
                    break;
                case "Pecheneg":
                    //avghk = 0.2446; 
                    avghkyellow = 0.66042; avghkred = 0.78272;
                    break;
                case "G36C":
                    //avghk = 0.2372;
                    avghkyellow = 0.64044; avghkred = 0.75904;
                    break;
                case "M412 Rex":
                    //avghk = 0.2388; 
                    avghkyellow = 0.64476; avghkred = 0.76416;
                    break;
                case "SV98":
                    //avghk = 0.5661.0;
                    avghkyellow = 1.5284; avghkred = 1.8115;
                    break;
                case "RPG-7":
                    //avghk = 1.0;
                    avghkyellow = 1.0; avghkred = 1.0;
                    break;
                case "Saiga":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "Glock 17":
                    //avghk = 0.2156; 
                    avghkyellow = 0.58212; avghkred = 0.68992;
                    break;
                case "AN94":
                    //avghk = 0.2354;
                    avghkyellow = 0.63558; avghkred = 0.75328;
                    break;
                case "M60":
                    //avghk = 0.243; 
                    avghkyellow = 0.6561; avghkred = 0.7776;
                    break;
                case "M27":
                    //avghk = 0.2421.0; 
                    avghkyellow = 0.65367; avghkred = 0.77472;
                    break;
                case "M1911 LIT":
                    //avghk = 0.2106; 
                    avghkyellow = 0.56862; avghkred = 0.67392;
                    break;
                case "SCAR":
                    //avghk = 0.2543;
                    avghkyellow = 0.68661; avghkred = 0.81376;
                    break;
                case "Glock 18 Silenced":
                    //avghk = 0.2427;
                    avghkyellow = 0.65529; avghkred = 0.77664;
                    break;
                case "UMP":
                    //avghk = 0.2071.0;
                    avghkyellow = 0.55917; avghkred = 0.66272;
                    break;
                case "PDR":
                    //avghk = 0.2104;
                    avghkyellow = 0.56808; avghkred = 0.67328;
                    break;
                case "M98B":
                    //avghk = 0.5686;
                    avghkyellow = 1.5274; avghkred = 1.8115;
                    break;
                case "M9 Silenced":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "XP2 L86A1":
                    //avghk = 0.2117; 
                    avghkyellow = 0.57159; avghkred = 0.67744;
                    break;
                case "M40A5":
                    //avghk = 0.5164; 
                    avghkyellow = 1.3942; avghkred = 1.6524;
                    break;
                case "USAS":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "XP2 LSAT":
                    //avghk = 0.22;
                    avghkyellow = 0.594; avghkred = 0.704;
                    break;
                case "XP1 QBB95":
                    //avghk = 0.245; 
                    avghkyellow = 0.6615; avghkred = 0.784;
                    break;
                case "XP1 HK53":
                    //avghk = 0.2215;
                    avghkyellow = 0.59805; avghkred = 0.7088;
                    break;
                case "M1911":
                    //avghk = 0.2136;
                    avghkyellow = 0.57672; avghkred = 0.68352;
                    break;
                case "XP1 QBU88":
                    //avghk = 0.3843;
                    avghkyellow = 1.0376; avghkred = 1.2297;
                    break;
                case "M16A4":
                    //avghk = 0.2312;
                    avghkyellow = 0.62424; avghkred = 0.73984;
                    break;
                case "XP2 AUG":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "M1014":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "AEK971":
                    //avghk = 0.225; 
                    avghkyellow = 0.6075; avghkred = 0.72;
                    break;
                case "G3A3":
                case "G3A4":
                    //avghk = 0.2548; 
                    avghkyellow = 0.68796; avghkred = 0.81536;
                    break;
                case "Taurus 44":
                    //avghk = 0.2434; 
                    avghkyellow = 0.65718; avghkred = 0.77888;
                    break;
                case "AKS74U":
                    //avghk = 0.2245;
                    avghkyellow = 0.60615; avghkred = 0.7184;
                    break;
                case "Glock 17 Silenced":
                    //avghk = 0.2058;
                    avghkyellow = 0.55566; avghkred = 0.65856;
                    break;
                case "M1911 Tactical":
                    //avghk = 0.2469;
                    avghkyellow = 0.66663; avghkred = 0.79008;
                    break;
                case "Underslung Launcher":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "M416":
                    //avghk = 0.2475;
                    avghkyellow = 0.66825; avghkred = 0.792;
                    break;
                case "Glock 18":
                    //avghk = 0.2572;
                    avghkyellow = 0.69444; avghkred = 0.82304;
                    break;
                case "FGM-148 JAVELIN":
                    //avghk = 1.0; 
                    avghkyellow = 1.0; avghkred = 1.0;
                    break;
                case "F2000":
                    //avghk = 0.2368;
                    avghkyellow = 0.63936; avghkred = 0.75776;
                    break;
                case "M1911 SILENCED":
                    //avghk = 0.2102; 
                    avghkyellow = 0.56754; avghkred = 0.67264;
                    break;
                case "MP443 LIT":
                    //avghk = 0.2262;
                    avghkyellow = 0.61074; avghkred = 0.72384;
                    break;
                case "Taurus 44 scoped":
                    //avghk = 0.2959; 
                    avghkyellow = 0.79893; avghkred = 0.94688;
                    break;
                case "XP1 L96":
                    //avghk = 0.5785; 
                    avghkyellow = 1.5619; avghkred = 1.8512;
                    break;
                case "RPK":
                    //avghk = 0.2384;
                    avghkyellow = 0.64368; avghkred = 0.76288;
                    break;
                case "XP1 FAMAS":
                    //avghk = 0.245;
                    avghkyellow = 0.6615; avghkred = 0.784;
                    break;
                case "AK74M":
                    //avghk = 0.2353;
                    avghkyellow = 0.63531; avghkred = 0.75296;
                    break;
                case "M249":
                    //avghk = 0.245;
                    avghkyellow = 0.6615; avghkred = 0.784;
                    break;
                case "A91":
                    //avghk = 0.2187;
                    avghkyellow = 0.59049; avghkred = 0.69984;
                    break;
                case "AS-VAL":
                    //avghk = 0.2585;
                    avghkyellow = 0.69795; avghkred = 0.8272;
                    break;
                case "P90":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "M93R":
                    //avghk = 0.2321.0;
                    avghkyellow = 0.62667; avghkred = 0.74272;
                    break;
                case "XP1 PP19":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "870":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "XP2 HK417":
                    //avghk = 0.288;
                    avghkyellow = 0.7776; avghkred = 0.9216;
                    break;
                case "MP443 Silenced":
                    //avghk = 0.215;
                    avghkyellow = 0.5805; avghkred = 0.688;
                    break;
                case "M9 Flashlight":
                    //avghk = 0.2106;
                    avghkyellow = 0.56862; avghkred = 0.67392;
                    break;
                case "PP2000":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "XP2 SPAS12":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "MP7":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "Underslung Shotgun":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "MP 443":
                    //avghk = 0.2018;
                    avghkyellow = 0.54486; avghkred = 0.64576;
                    break;
                case "XP1 L85A2":
                    //avghk = 0.2177; 
                    avghkyellow = 0.58779; avghkred = 0.69664;
                    break;
                case "DAO":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "SG553":
                    //avghk = 0.2234;
                    avghkyellow = 0.60318; avghkred = 0.71488;
                    break;
                case "Type88":
                    //avghk = 0.2401.0;
                    avghkyellow = 0.64827; avghkred = 0.76832;
                    break;
                case "SA-18 IGLA AA":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "Knife":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "M240":
                    //avghk = 0.2449; 
                    avghkyellow = 0.66123; avghkred = 0.78368;
                    break;
                case "XP2 MTAR-21":
                    //avghk = 0.2119;
                    avghkyellow = 0.57213; avghkred = 0.67808;
                    break;
                case "KH2002":
                    //avghk = 0.2448; 
                    avghkyellow = 0.66096; avghkred = 0.78336;
                    break;
                case "XP1 Jackhammer":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "XP2 SCARL":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "XP2 MP5K":
                    //avghk = 0.2091.0;
                    avghkyellow = 0.56457; avghkred = 0.66912;
                    break;
                case "FIM-92 STINGER AA":
                    //avghk = 0.2; 
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "M9":
                    //avghk = 0.2061.0;
                    avghkyellow = 0.55647; avghkred = 0.65952;
                    break;
                case "XP2 ACR":
                    //avghk = 0.2;
                    avghkyellow = 0.54; avghkred = 0.64;
                    break;
                case "M4A1":
                    //avghk = 0.2283; 
                    avghkyellow = 0.61641; avghkred = 0.73056;
                    break;
                case "XP2 JNG90":
                    //avghk = 0.4672; 
                    avghkyellow = 1.2614; avghkred = 1.495;
                    break;
                case "XP1 QBZ95B":
                    //avghk = 0.2083;
                    avghkyellow = 0.56241; avghkred = 0.66656;
                    break;
                case "XP1 MG36":
                    //avghk = 0.2502;
                    avghkyellow = 0.67554; avghkred = 0.80064;
                    break;
                case "Mk153 SMAW":
                    //avghk = 1.0;
                    avghkyellow = 1.0; avghkred = 1.0;
                    break;


                default:
                    log("CD - weapon avg headshots/kill not found: " + weaponname, 1);
                    //avghk = 1.0;
                    avghkyellow = 100; avghkred = 100;
                    break;
            }

            double hspk = Math.Round((headshots / kills) * 100.0, 2);
            double hspkabove = Math.Round((headshots / kills) / (avghkyellow/2.7), 2);
            
            double cheatindex = 0.0;
            if (kills > minkills/* || (kills > 20 && headshots > kills)*/)
            {
                if ((headshots / kills) > avghkred)
                {
                    log("CD - IMPOSSIBLE STATS: " + playername + " " + weaponname + " hs/k: " + hspk.ToString() + "%" + " (" + hspkabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(hspkabove))
                        reasons.Add(hspkabove, weaponname + " hs/k: " + hspk.ToString() + "%");

                    cheatindex += redflagcount;
                }
                else if ((headshots / kills) > avghkyellow)
                {
                    log("CD - suspicious stats: " + playername + " " + weaponname + " hs/k: " + hspk.ToString() + "%" + " (" + hspkabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(hspkabove))
                        reasons.Add(hspkabove, weaponname + " hs/k: " + hspk.ToString() + "%");

                    cheatindex += orangeflagcount;
                }
            }
            else
            {
                log("CD - skipping weapon (less than " + minkills.ToString() + " kills): " + weaponname, 5);
            }
            log("CD - headshot/kill: " + hspk.ToString() + "%", 5);
            return cheatindex;
        }
        #endregion

        #region checkAccuracy
        public double checkAccuracy(ref Dictionary<double, string> reasons, string playername, string weaponname, double weaponacc, double kills)
        {
            if (weaponname == "Underslung Shotgun" || weaponname == "XP1 Jackhammer" || weaponname == "M1014" || weaponname == "DAO" || weaponname == "XP2 SPAS12" || weaponname == "870" || weaponname == "USAS" || weaponname == "Saiga" || weaponname == "RPG-7" || weaponname == "Mk153 SMAW" || weaponname == "FGM-148 JAVELIN" || weaponname == "Underslung Launcher" || weaponname == "SA-18 IGLA AA" || weaponname == "FIM-92 STINGER AA" || weaponname == "Knife") //unreliable
                return 0.0;

            if (weaponname == "Crossbow Scoped" || weaponname == "Crossbow kobra") //no avg yet
                return 0.0;

            //double avgacc;
            double avgaccyellow;
            double avgaccred;

            switch (weaponname)
            {
                case "MK11":
                    //avgacc = 0.2333;
                    avgaccyellow = 0.74656;
                    avgaccred = 0.86321;
                    break;
                case "SVD":
                    //avgacc = 0.2327;
                    avgaccyellow = 0.74464;
                    avgaccred = 0.86099;
                    break;
                case "SKS":
                    //avgacc = 0.1921;
                    avgaccyellow = 0.61472;
                    avgaccred = 0.71077;
                    break;
                case "M39":
                    //avgacc = 0.229; 
                    avgaccyellow = 0.7328; avgaccred = 0.8473;
                    break;
                case "Pecheneg":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "G36C":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M412 Rex":
                    //avgacc = 0.2498; 
                    avgaccyellow = 0.79936; avgaccred = 0.92426;
                    break;
                case "SV98":
                    //avgacc = 0.2999; 
                    avgaccyellow = 0.95968; avgaccred = 1.0;//1.10963;
                    break;
                case "RPG-7":
                    //avgacc = 0.5626; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//2.08162;
                    break;
                case "Saiga":
                    //avgacc = 0.4843; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.79191;
                    break;
                case "Glock 17":
                    //avgacc = 0.2023; 
                    avgaccyellow = 0.64736; avgaccred = 0.74851;
                    break;
                case "AN94":
                    //avgacc = 0.1712; 
                    avgaccyellow = 0.54784; avgaccred = 0.63344;
                    break;
                case "M60":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M27":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M1911 LIT":
                    //avgacc = 0.2118; 
                    avgaccyellow = 0.67776; avgaccred = 0.78366;
                    break;
                case "SCAR":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Glock 18 Silenced":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "UMP":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "PDR":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M98B":
                    //avgacc = 0.3158; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.16846;
                    break;
                case "M9 Silenced":
                    //avgacc = 0.218; 
                    avgaccyellow = 0.6976; avgaccred = 0.8066;
                    break;
                case "XP2 L86A1":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M40A5":
                    //avgacc = 0.3243; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.19991;
                    break;
                case "USAS":
                    //avgacc = 0.3439; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.27243;
                    break;
                case "XP2 LSAT":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP1 QBB95":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP1 HK53":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M1911":
                    //avgacc = 0.2142; 
                    avgaccyellow = 0.68544; avgaccred = 0.79254;
                    break;
                case "XP1 QBU88":
                    //avgacc = 0.235; 
                    avgaccyellow = 0.752; avgaccred = 0.8695;
                    break;
                case "M16A4":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP2 AUG":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M1014":
                    //avgacc = 0.5052; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.86924;
                    break;
                case "AEK971":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "G3A3":
                case "G3A4":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Taurus 44":
                    //avgacc = 0.2713; 
                    avgaccyellow = 0.86816; avgaccred = 1.00381;
                    break;
                case "AKS74U":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Glock 17 Silenced":
                    //avgacc = 0.2126; 
                    avgaccyellow = 0.68032; avgaccred = 0.78662;
                    break;
                case "M1911 Tactical":
                    //avgacc = 0.2075; 
                    avgaccyellow = 0.664; avgaccred = 0.76775;
                    break;
                case "Underslung Launcher":
                    //avgacc = 0.4964; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.83668;
                    break;
                case "M416":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Glock 18":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "FGM-148 JAVELIN":
                    //avgacc = 0.5585; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//2.06645;
                    break;
                case "F2000":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M1911 SILENCED":
                    //avgacc = 0.2231; 
                    avgaccyellow = 0.71392; avgaccred = 0.82547;
                    break;
                case "MP443 LIT":
                    //avgacc = 0.2017; 
                    avgaccyellow = 0.64544; avgaccred = 0.74629;
                    break;
                case "Taurus 44 scoped":
                    //avgacc = 0.272; 
                    avgaccyellow = 0.8704; avgaccred = 1.0064;
                    break;
                case "XP1 L96":
                    //avgacc = 0.3132; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.15884;
                    break;
                case "RPK":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP1 FAMAS":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "AK74M":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M249":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "A91":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "AS-VAL":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "P90":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M93R":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP1 PP19":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "870":
                    //avgacc = 0.4245; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.57065;
                    break;
                case "XP2 HK417":
                    //avgacc = 0.1896; 
                    avgaccyellow = 0.60672; avgaccred = 0.70152;
                    break;
                case "MP443 Silenced":
                    //avgacc = 0.2157; 
                    avgaccyellow = 0.69024; avgaccred = 0.79809;
                    break;
                case "M9 Flashlight":
                    //avgacc = 0.2039; 
                    avgaccyellow = 0.65248; avgaccred = 0.75443;
                    break;
                case "PP2000":
                    //avgacc = 0.17;
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP2 SPAS12":
                    //avgacc = 0.6636;
                    avgaccyellow = 1.0; avgaccred = 1.0;//2.45532;
                    break;
                case "MP7":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Underslung Shotgun":
                    //avgacc = 0.7438; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//2.75206;
                    break;
                case "MP 443":
                    //avgacc = 0.2121;
                    avgaccyellow = 0.67872; avgaccred = 0.78477;
                    break;
                case "XP1 L85A2":
                    //avgacc = 0.17;
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "DAO":
                    //avgacc = 0.4483;
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.65871;
                    break;
                case "SG553":
                    //avgacc = 0.17;
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Type88":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "SA-18 IGLA AA":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Knife":
                    //avgacc = 0.2323; 
                    avgaccyellow = 0.74336; avgaccred = 0.85951;
                    break;
                case "M240":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP2 MTAR-21":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "KH2002":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP1 Jackhammer":
                    //avgacc = 0.4368; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.61616;
                    break;
                case "XP2 SCARL":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP2 MP5K":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "FIM-92 STINGER AA":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M9":
                    //avgacc = 0.2049; 
                    avgaccyellow = 0.65568; avgaccred = 0.75813;
                    break;
                case "XP2 ACR":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "M4A1":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP2 JNG90":
                    //avgacc = 0.323; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.1951;
                    break;
                case "XP1 QBZ95B":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "XP1 MG36":
                    //avgacc = 0.17; 
                    avgaccyellow = 0.544; avgaccred = 0.629;
                    break;
                case "Mk153 SMAW":
                    //avgacc = 0.5397; 
                    avgaccyellow = 1.0; avgaccred = 1.0;//1.99689;
                    break;

                default:
                    log("CD - weapon avg accuracy not found: " + weaponname, 1);
                    avgaccyellow = 100; avgaccred = 100;
                    break;
            }

            double acc = Math.Round(weaponacc * 100.0, 2);
            double accabove = Math.Round(weaponacc / (avgaccyellow/3.2), 2);
            
            double cheatindex = 0.0;
            if (kills > minkills)
            {                
                if (weaponacc > avgaccred)
                {
                    log("CD - IMPOSSIBLE STATS: " + playername + " " + weaponname + " accuracy: " + acc.ToString() + "%" + " (" + accabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(accabove))
                    {
                        reasons.Add(accabove, weaponname + " accuracy: " + acc.ToString() + "%");
                    }

                    cheatindex += redflagcount;
                }
                else if (weaponacc > avgaccyellow)
                {
                    log("CD - suspicious stats: " + playername + " " + weaponname + " accuracy: " + acc.ToString() + "%" + " (" + accabove.ToString() + ")", 1);
                    if (!reasons.ContainsKey(accabove))
                    {
                        reasons.Add(accabove, weaponname + " accuracy: " + acc.ToString() + "%");
                    }

                    cheatindex += orangeflagcount;
                }
            }
            else
            {
                log("CD - skipping weapon (less than " + minkills.ToString() + " kills): " + weaponname, 5);
            }
            log("CD - Accuracy: " + acc.ToString() + "%", 5);
            return cheatindex;
        }
        #endregion

        #region log
        public void log(string msg, int debuglvl)
        {
            if (debuglevel >= debuglvl)
            {
                ExecuteCommand("procon.protected.pluginconsole.write", msg);

                if (logtofile == enumBoolYesNo.Yes)
                {
                    try
                    {
                        string file = Path.Combine(Directory.GetParent(Application.ExecutablePath).FullName, logfilename);

                        if (!File.Exists(file))
                        {
                            File.Create(file);
                        }

                        using (FileStream fs = File.Open(file, FileMode.Append))
                        {
                            Byte[] bytes = new UTF8Encoding(true).GetBytes(DateTime.Now.ToString() + ": " + msg + Environment.NewLine);
                            fs.Write(bytes, 0, bytes.Length);
                        }
                    }
                    catch (Exception ex)
                    {
                        ExecuteCommand("unable to append data to file " + ex.Message);
                    }
                }
            }
        }
        #endregion

        #region OnReservedSlotsList
        public override void OnReservedSlotsList(List<string> soldierNames)
        {
            if (includereservedslots == enumBoolYesNo.Yes)
            {
                foreach (string vipplayer in soldierNames)
                {
                    if (!whitelist.Contains(vipplayer))
                    {
                        whitelist.Add(vipplayer);
                    }
                }
            }
            if (excludereservedslots == enumBoolYesNo.Yes)
            {
                List<string> playerstoremove = new List<string>();
                foreach (string vipplayer in whitelist)
                {
                    if (!soldierNames.Contains(vipplayer))
                    {
                        playerstoremove.Add(vipplayer);
                    }
                }
                foreach (string player in playerstoremove)
                {
                    whitelist.Remove(player);
                }
            }
        }
        #endregion

        #region IsCacheEnabled
        public bool IsCacheEnabled(bool showMessage)
        {
            List<MatchCommand> registered = GetRegisteredCommands();
            foreach (MatchCommand command in registered)
            {
                if (useCache == enumBoolYesNo.Yes && command.RegisteredClassname.CompareTo("CBattlelogCache") == 0 && command.RegisteredMethodName.CompareTo("PlayerLookup") == 0)
                {
                    if (showMessage)
                    {
                        log("CD - Battlelog Cache plugin will be used for stats fetching.", 1);
                    }
                    return true;
                }
            }
            if (showMessage)
            {
                log("CD - Battlelog Cache plugin is disabled. Installing/updating and enabling the plugin is recommended, if you run other Plugins that require Battlelog Stats (Insane Limits, True Balancer).", 1);
            }
            return false;
        }
        #endregion

        #region GenerateRandomString
        public static string GenerateRandomString()
        {
            string path = Path.GetRandomFileName() + Path.GetRandomFileName() + Path.GetRandomFileName();
            path = path.Replace(".", ""); // Remove period.
            return path;
        }
        #endregion

        #region formatMsg
        private string formatMsg(string msg, string playername, string bestreason, string pbguid, string eaguid)
        {
            string returntext = msg;
            returntext = returntext.Replace("%suspiciousstat%", bestreason.ToString());
            returntext = returntext.Replace("%playername%", playername);
            returntext = returntext.Replace("%pbguid%", pbguid);
            returntext = returntext.Replace("%eaguid%", eaguid);
            return returntext;
        }
        #endregion

        #region OnPunkbusterPlayerInfo
        public override void OnPunkbusterPlayerInfo(CPunkbusterInfo playerInfo)
        {
            log("CD - getting PB Info for player: " + playerInfo.SoldierName, 5);
            if (!m_dicPBPlayerInfo.ContainsKey(playerInfo.SoldierName))
            {
                log("CD - adding PB Info for player: " + playerInfo.SoldierName, 4);
                m_dicPBPlayerInfo.Add(playerInfo.SoldierName, playerInfo);
            }
        }
        #endregion

        #region backAdd
        private void backAdd(string playername)
        {
            lock (playerErrors)
            {
                if (!playerErrors.ContainsKey(playername))
                {
                    playerErrors.Add(playername, 1);
                }

                if (myplayerlist.Contains(playername) && playerErrors[playername] <= retries)
                {
                    log("CD - Error detected, checking player " + playername + " again later.", 2);
                    myplayerlist.Remove(playername);
                    playerErrors[playername]++;
                }
                else
                {
                    log("CD - NOT checking player " + playername + " again. Too many errors or not in playerlist anymore.", 3);
                }
            }
        }
        #endregion

        #region class BattlelogClient
        public class BattlelogClient
        {
            private CheatDetector plugin = null;

            public BattlelogClient(CheatDetector p)
            {
                plugin = p;
            }

            //private HttpWebRequest req = null;

            WebClient client = null;

            public String fetchWebPage(ref String html_data, String url)
            {
                try
                {
                    ////plugin.timeouttesthelper++;

                    //if (plugin.timeouttesthelper >= 5)
                    //{
                    //    plugin.timeouttesthelper = 0;
                    //    throw new WebException("timeout test");                        
                    //}

                    if (plugin.timeouttest == enumBoolYesNo.Yes)
                    {
                        //Random random = new Random();
                        //int blub = random.Next(1, 6);
                        //if (blub == 3)
                        throw new WebException("timeout test");
                    }

                    if (client == null)
                    {
                        client = new WebClient();
                        client.Headers.Add("user-agent", plugin.UserAgent);
                    }

                    html_data = client.DownloadString(url);
                    return html_data;

                }
                catch (WebException e)
                {
                    if (e.Status.Equals(WebExceptionStatus.Timeout))
                    {
                        throw new Exception("HTTP request timed-out");
                    }
                    else
                    {
                        throw;
                    }

                }
            }
        }
        #endregion

        #region Exceptions
        public class StatsException : Exception
        {
            public StatsException(String message)
                : base(message)
            {
            }
        }
        #endregion

        public class DBConnect
        {
            private MySqlConnection connection;
            //private string server;
            //private string database;
            //private string uid;
            //private string password;
            private CheatDetector plugin;
            private bool connectionisopen = false;

            //Constructor
            public DBConnect(CheatDetector p)
            {
                plugin = p;
                Initialize(p.queueServer, p.queueDB, p.queueUser, p.queuePwd);
            }

            //Initialize values
            private void Initialize(string srv, string db, string user, string pwd)
            {
                string connectionString;
                connectionString = "SERVER=" + srv + ";" + "DATABASE=" + db + ";Connect Timeout=25;" + "UID=" + user + ";" + "PASSWORD=" + pwd + ";";

                connection = new MySqlConnection(connectionString);
            }

            //open connection to database
            private bool OpenConnection()
            {
                if (connectionisopen)
                {
                    return true;
                }

                try
                {
                    connection.Open();
                    connectionisopen = true;
                    return true;
                }
                catch (MySqlException ex)
                {
                    //When handling errors, you can your application's response based 
                    //on the error number.
                    //The two most common error numbers when connecting are as follows:
                    //0: Cannot connect to server.
                    //1045: Invalid user name and/or password.
                    switch (ex.Number)
                    {
                        case 0:
                            plugin.log("CD - Cannot connect to server.  Contact administrator", 1);
                            break;

                        case 1045:
                            plugin.log("CD - Invalid username/password, please try again", 1);
                            break;
                    }
                    return false;
                }
            }

            //Close connection
            private bool CloseConnection()
            {
                try
                {
                    connection.Close();
                    connectionisopen = false;
                    return true;
                }
                catch (MySqlException ex)
                {
                    plugin.log("CD - " + ex, 1);
                    return false;
                }
            }

            //Insert statement
            public bool Insert(PlayerCheckInfo[] p)
            {
                
                    try
                    {
                        if (p.Length > 0)
                        {
                            plugin.log("CD - adding players to master queue", 3);

                            string tempqueryfordb = "INSERT INTO cd_queue (name, eaguid, pbguid, firstseen, lastseen, prio) VALUES ";

                            int i = 0;
                            foreach (PlayerCheckInfo player in p)
                            {
                                i++;
                                tempqueryfordb += "('" + MySqlHelper.EscapeString(player.name) + "', '" + player.eaguid + "', '" + player.pbguid + "', '" + DateTime.UtcNow.AddHours(1).ToString("yyyy.MM.dd HH:mm:ss") + "', '" + DateTime.UtcNow.AddHours(1).ToString("yyyy.MM.dd HH:mm:ss") + "', '" + player._prio.ToString() + "')";
                                if (i < p.Length)
                                {
                                    tempqueryfordb += ", ";
                                }
                            }

                            tempqueryfordb += " ON DUPLICATE KEY UPDATE lastseen=VALUES(lastseen), prio=VALUES(prio)";

                            if (RunQuery(tempqueryfordb))
                            {
                                return true;
                            }
                            else
                            {
                                return false;
                            }
                        }
                        else
                        {                            
                            plugin.log("CD - nothing to do for master queue", 3);
                            return true;
                        }
                    }
                    catch (Exception ex)
                    {
                        plugin.log("CD - ERROR DB.Insert(): " + ex, 1);
                        return false;
                    }
                
            }

            ////Update statement
            //public bool Update(MyPlayerinfo p)
            //{
            //    try
            //    {
            //        string query = "UPDATE awards SET time='" + p.time.ToString(new System.Globalization.CultureInfo("en-US")) + "', isVIP='" + (p.isVIP ? "1" : "0") + "', kicks='" + p.kicks.ToString() + "', tbans='" + p.tbans.ToString() + "', bans='" + p.bans.ToString() + "', reset='" + p.reset.ToString() + "' WHERE name='" + p.name.ToString() + "'";

            //        //Open connection
            //        if (this.OpenConnection() == true)
            //        {
            //            //create mysql command
            //            MySqlCommand cmd = new MySqlCommand();
            //            //Assign the query using CommandText
            //            cmd.CommandText = query;
            //            //Assign the connection using Connection
            //            cmd.Connection = connection;

            //            //Execute query
            //            cmd.ExecuteNonQuery();

            //            //close connection
            //            this.CloseConnection();
            //        }
            //        return true;
            //    }
            //    catch (Exception ex)
            //    {
            //        plugin.log("CD - ERROR DB.Update(): " + ex, 1);
            //        return false;
            //    }
            //}

            public bool RunQuery(string query)
            {
                try
                {
                    //Open connection
                    if (this.OpenConnection() == true)
                    {
                        //create mysql command
                        MySqlCommand cmd = new MySqlCommand();
                        //Assign the query using CommandText
                        cmd.CommandText = query;
                        //Assign the connection using Connection
                        cmd.Connection = connection;

                        cmd.CommandTimeout = 25;

                        //Execute query
                        cmd.ExecuteNonQuery();

                        //close connection
                        this.CloseConnection();
                    }
                    return true;
                }
                catch (Exception ex)
                {
                    plugin.log("CD - ERROR DB.RunQuery(): " + ex, 1);
                    return false;
                }
            }

            ////Delete statement
            ////public void Delete(MyPlayerinfo p)
            ////{
            ////}

            ////Select statement
            //public MyPlayerinfo GetPlayerStats(string p)
            //{
            //    MyPlayerinfo stats = new MyPlayerinfo();
            //    stats.successfullDBFetch = false;
            //    try
            //    {
            //        string query = "SELECT * FROM awards WHERE name='" + p + "'";

            //        //Open connection
            //        if (this.OpenConnection() == true)
            //        {
            //            //Create Command
            //            MySqlCommand cmd = new MySqlCommand(query, connection);
            //            //Create a data reader and Execute the command
            //            MySqlDataReader dataReader = cmd.ExecuteReader();

            //            //Read the data and store them in the list
            //            while (dataReader.Read())
            //            {
            //                stats.name = p;
            //                stats.time = Convert.ToDouble(dataReader["time"]);
            //                stats.isVIP = Convert.ToBoolean(dataReader["isVIP"]);
            //                stats.kills = Convert.ToInt32(dataReader["kills"]);
            //                stats.moves = Convert.ToInt32(dataReader["moves"]);
            //                stats.kicks = Convert.ToInt32(dataReader["kicks"]);
            //                stats.tbans = Convert.ToInt32(dataReader["tbans"]);
            //                stats.bans = Convert.ToInt32(dataReader["bans"]);
            //                stats.reset = Convert.ToDateTime(dataReader["reset"]);
            //                //stats.resetRightsby = Convert.ToDateTime(dataReader["resetRightsby"]);
            //                stats.successfullDBFetch = true;
            //            }

            //            //close Data Reader
            //            dataReader.Close();

            //            //close Connection
            //            this.CloseConnection();

            //            //return list to be displayed
            //            return stats;
            //        }
            //        else
            //        {
            //            return stats;
            //        }
            //    }
            //    catch (Exception ex)
            //    {
            //        plugin.log("CD - ERROR DB.GetPlayerStats(): " + ex, 1);
            //        return stats;
            //    }
            //}

            //public object GetSetting(string p)
            //{
            //    object value = "";
            //    try
            //    {
            //        string query = "SELECT * FROM awards_settings WHERE name='" + p + "'";

            //        //Open connection
            //        if (this.OpenConnection() == true)
            //        {
            //            //Create Command
            //            MySqlCommand cmd = new MySqlCommand(query, connection);
            //            //Create a data reader and Execute the command
            //            MySqlDataReader dataReader = cmd.ExecuteReader();

            //            //Read the data and store them in the list
            //            while (dataReader.Read())
            //            {

            //                value = dataReader["value"];

            //            }

            //            //close Data Reader
            //            dataReader.Close();

            //            //close Connection
            //            this.CloseConnection();

            //            //return list to be displayed
            //            return value;
            //        }
            //        else
            //        {
            //            return value;
            //        }
            //    }
            //    catch (Exception ex)
            //    {
            //        plugin.log("CD - ERROR DB.GetPlayerStats(): " + ex, 1);
            //        return value;
            //    }
            //}

            ////Count statement
            //public bool PlayerExists(string p)
            //{
            //    try
            //    {
            //        string query = "SELECT Count(*) FROM awards WHERE name='" + p + "'";
            //        int Count = -1;

            //        //Open Connection
            //        if (this.OpenConnection() == true)
            //        {
            //            //Create Mysql Command
            //            MySqlCommand cmd = new MySqlCommand(query, connection);

            //            //ExecuteScalar will return one value
            //            Count = int.Parse(cmd.ExecuteScalar() + "");

            //            //close Connection
            //            this.CloseConnection();

            //            return Count > 0;
            //        }
            //        else
            //        {
            //            return false;
            //        }
            //    }
            //    catch (Exception ex)
            //    {
            //        plugin.log("CD - ERROR DB.PlayerExists() " + ex, 1);
            //        return false;
            //    }
            //}

            ////Backup
            ////public void Backup()
            ////{
            ////}

            //////Restore
            ////public void Restore()
            ////{
            ////}
        }

        public class PlayerCheckInfo
        {            
            public string name;
            public string eaguid;
            public string pbguid;
            public int _prio;

            public PlayerCheckInfo(string n, string eag, string pbg, int prio)
            {                
                name = n;
                eaguid = eag;
                pbguid = pbg;
                _prio = prio;
            }

            public string ToString()
            {
                return name;
            }
        }
                
    }


}